=begin comment

Figshare API

Figshare apiv2. Using Swagger 2.0

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git

=end comment

=cut

#
# NOTE: This class is auto generated by the swagger code generator program. 
# Do not edit the class manually.
# Ref: https://github.com/swagger-api/swagger-codegen
#
package WWW::SwaggerClient::ArticlesApi;

require 5.6.0;
use strict;
use warnings;
use utf8; 
use Exporter;
use Carp qw( croak );
use Log::Any qw($log);

use WWW::SwaggerClient::ApiClient;

use base "Class::Data::Inheritable";

__PACKAGE__->mk_classdata('method_documentation' => {});

sub new {
    my $class = shift;
    my $api_client;

    if ($_[0] && ref $_[0] && ref $_[0] eq 'WWW::SwaggerClient::ApiClient' ) {
        $api_client = $_[0];
    } else {
        $api_client = WWW::SwaggerClient::ApiClient->new(@_);
    }

    bless { api_client => $api_client }, $class;

}


#
# account_article_report
#
# Account Article Report
# 
# @param int $group_id A group ID to filter by (optional)
{
    my $params = {
    'group_id' => {
        data_type => 'int',
        description => 'A group ID to filter by',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'account_article_report' } = { 
    	summary => 'Account Article Report',
        params => $params,
        returns => 'ARRAY[AccountReport]',
        };
}
# @return ARRAY[AccountReport]
#
sub account_article_report {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/account/articles/export';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # query params
    if ( exists $args{'group_id'}) {
        $query_params->{'group_id'} = $self->{api_client}->to_query_value($args{'group_id'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[AccountReport]', $response);
    return $_response_object;
}

#
# account_article_report_generate
#
# Initiate a new Report
# 
{
    my $params = {
    };
    __PACKAGE__->method_documentation->{ 'account_article_report_generate' } = { 
    	summary => 'Initiate a new Report',
        params => $params,
        returns => 'AccountReport',
        };
}
# @return AccountReport
#
sub account_article_report_generate {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/account/articles/export';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('AccountReport', $response);
    return $_response_object;
}

#
# article_details
#
# View article details
# 
# @param int $article_id Article Unique identifier (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article Unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'article_details' } = { 
    	summary => 'View article details',
        params => $params,
        returns => 'ArticleComplete',
        };
}
# @return ArticleComplete
#
sub article_details {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling article_details");
    }

    # parse inputs
    my $_resource_path = '/articles/{article_id}';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ArticleComplete', $response);
    return $_response_object;
}

#
# article_file_details
#
# Article file details
# 
# @param int $article_id Article Unique identifier (required)
# @param int $file_id File Unique identifier (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article Unique identifier',
        required => '1',
    },
    'file_id' => {
        data_type => 'int',
        description => 'File Unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'article_file_details' } = { 
    	summary => 'Article file details',
        params => $params,
        returns => 'PublicFile',
        };
}
# @return PublicFile
#
sub article_file_details {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling article_file_details");
    }

    # verify the required parameter 'file_id' is set
    unless (exists $args{'file_id'}) {
      croak("Missing the required parameter 'file_id' when calling article_file_details");
    }

    # parse inputs
    my $_resource_path = '/articles/{article_id}/files/{file_id}';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'file_id'}) {
        my $_base_variable = "{" . "file_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'file_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('PublicFile', $response);
    return $_response_object;
}

#
# article_files
#
# List article files
# 
# @param int $article_id Article Unique identifier (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article Unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'article_files' } = { 
    	summary => 'List article files',
        params => $params,
        returns => 'ARRAY[PublicFile]',
        };
}
# @return ARRAY[PublicFile]
#
sub article_files {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling article_files");
    }

    # parse inputs
    my $_resource_path = '/articles/{article_id}/files';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[PublicFile]', $response);
    return $_response_object;
}

#
# article_version_confidentiality
#
# Public Article Confidentiality for article version
# 
# @param int $article_id Article Unique identifier (required)
# @param int $v_number Version Number (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article Unique identifier',
        required => '1',
    },
    'v_number' => {
        data_type => 'int',
        description => 'Version Number',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'article_version_confidentiality' } = { 
    	summary => 'Public Article Confidentiality for article version',
        params => $params,
        returns => 'ArticleConfidentiality',
        };
}
# @return ArticleConfidentiality
#
sub article_version_confidentiality {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling article_version_confidentiality");
    }

    # verify the required parameter 'v_number' is set
    unless (exists $args{'v_number'}) {
      croak("Missing the required parameter 'v_number' when calling article_version_confidentiality");
    }

    # parse inputs
    my $_resource_path = '/articles/{article_id}/versions/{v_number}/confidentiality';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'v_number'}) {
        my $_base_variable = "{" . "v_number" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'v_number'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ArticleConfidentiality', $response);
    return $_response_object;
}

#
# article_version_details
#
# Article details for version
# 
# @param int $article_id Article Unique identifier (required)
# @param int $v_number Article Version Number (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article Unique identifier',
        required => '1',
    },
    'v_number' => {
        data_type => 'int',
        description => 'Article Version Number',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'article_version_details' } = { 
    	summary => 'Article details for version',
        params => $params,
        returns => 'ArticleComplete',
        };
}
# @return ArticleComplete
#
sub article_version_details {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling article_version_details");
    }

    # verify the required parameter 'v_number' is set
    unless (exists $args{'v_number'}) {
      croak("Missing the required parameter 'v_number' when calling article_version_details");
    }

    # parse inputs
    my $_resource_path = '/articles/{article_id}/versions/{v_number}';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'v_number'}) {
        my $_base_variable = "{" . "v_number" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'v_number'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ArticleComplete', $response);
    return $_response_object;
}

#
# article_version_embargo
#
# Public Article Embargo for article version
# 
# @param int $article_id Article Unique identifier (required)
# @param int $v_number Version Number (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article Unique identifier',
        required => '1',
    },
    'v_number' => {
        data_type => 'int',
        description => 'Version Number',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'article_version_embargo' } = { 
    	summary => 'Public Article Embargo for article version',
        params => $params,
        returns => 'ArticleEmbargo',
        };
}
# @return ArticleEmbargo
#
sub article_version_embargo {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling article_version_embargo");
    }

    # verify the required parameter 'v_number' is set
    unless (exists $args{'v_number'}) {
      croak("Missing the required parameter 'v_number' when calling article_version_embargo");
    }

    # parse inputs
    my $_resource_path = '/articles/{article_id}/versions/{v_number}/embargo';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'v_number'}) {
        my $_base_variable = "{" . "v_number" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'v_number'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ArticleEmbargo', $response);
    return $_response_object;
}

#
# article_version_update
#
# Update article version
# 
# @param int $article_id Article unique identifier (required)
# @param int $version_id Article version identifier (required)
# @param ArticleUpdate $article Article description (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    'version_id' => {
        data_type => 'int',
        description => 'Article version identifier',
        required => '1',
    },
    'article' => {
        data_type => 'ArticleUpdate',
        description => 'Article description',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'article_version_update' } = { 
    	summary => 'Update article version',
        params => $params,
        returns => 'LocationWarningsUpdate',
        };
}
# @return LocationWarningsUpdate
#
sub article_version_update {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling article_version_update");
    }

    # verify the required parameter 'version_id' is set
    unless (exists $args{'version_id'}) {
      croak("Missing the required parameter 'version_id' when calling article_version_update");
    }

    # verify the required parameter 'article' is set
    unless (exists $args{'article'}) {
      croak("Missing the required parameter 'article' when calling article_version_update");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}/versions/{version_id}/';

    my $_method = 'PUT';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'version_id'}) {
        my $_base_variable = "{" . "version_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'version_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'article'}) {
        $_body_data = $args{'article'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('LocationWarningsUpdate', $response);
    return $_response_object;
}

#
# article_version_update_thumb
#
# Update article version thumbnail
# 
# @param int $article_id Article unique identifier (required)
# @param int $version_id Article version identifier (required)
# @param FileId $file_id File ID (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    'version_id' => {
        data_type => 'int',
        description => 'Article version identifier',
        required => '1',
    },
    'file_id' => {
        data_type => 'FileId',
        description => 'File ID',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'article_version_update_thumb' } = { 
    	summary => 'Update article version thumbnail',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub article_version_update_thumb {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling article_version_update_thumb");
    }

    # verify the required parameter 'version_id' is set
    unless (exists $args{'version_id'}) {
      croak("Missing the required parameter 'version_id' when calling article_version_update_thumb");
    }

    # verify the required parameter 'file_id' is set
    unless (exists $args{'file_id'}) {
      croak("Missing the required parameter 'file_id' when calling article_version_update_thumb");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}/versions/{version_id}/update_thumb';

    my $_method = 'PUT';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'version_id'}) {
        my $_base_variable = "{" . "version_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'version_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'file_id'}) {
        $_body_data = $args{'file_id'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# article_versions
#
# List article versions
# 
# @param int $article_id Article Unique identifier (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article Unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'article_versions' } = { 
    	summary => 'List article versions',
        params => $params,
        returns => 'ARRAY[ArticleVersions]',
        };
}
# @return ARRAY[ArticleVersions]
#
sub article_versions {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling article_versions");
    }

    # parse inputs
    my $_resource_path = '/articles/{article_id}/versions';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[ArticleVersions]', $response);
    return $_response_object;
}

#
# articles_list
#
# Public Articles
# 
# @param UUID $x_cursor Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)
# @param int $page Page number. Used for pagination with page_size (optional)
# @param int $page_size The number of results included on a page. Used for pagination with page (optional, default to 10)
# @param int $limit Number of results included on a page. Used for pagination with query (optional)
# @param int $offset Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
# @param string $order The field by which to order. Default varies by endpoint/resource. (optional, default to published_date)
# @param string $order_direction  (optional, default to desc)
# @param int $institution only return articles from this institution (optional)
# @param string $published_since Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)
# @param string $modified_since Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)
# @param int $group only return articles from this group (optional)
# @param string $resource_doi only return articles with this resource_doi (optional)
# @param int $item_type Only return articles with the respective type. Mapping for item_type is: 1 - Figure, 2 - Media, 3 - Dataset, 5 - Poster, 6 - Journal contribution, 7 - Presentation, 8 - Thesis, 9 - Software, 11 - Online resource, 12 - Preprint, 13 - Book, 14 - Conference contribution, 15 - Chapter, 16 - Peer review, 17 - Educational resource, 18 - Report, 19 - Standard, 20 - Composition, 21 - Funding, 22 - Physical object, 23 - Data management plan, 24 - Workflow, 25 - Monograph, 26 - Performance, 27 - Event, 28 - Service, 29 - Model (optional)
# @param string $doi only return articles with this doi (optional)
# @param string $handle only return articles with this handle (optional)
{
    my $params = {
    'x_cursor' => {
        data_type => 'UUID',
        description => 'Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected.',
        required => '0',
    },
    'page' => {
        data_type => 'int',
        description => 'Page number. Used for pagination with page_size',
        required => '0',
    },
    'page_size' => {
        data_type => 'int',
        description => 'The number of results included on a page. Used for pagination with page',
        required => '0',
    },
    'limit' => {
        data_type => 'int',
        description => 'Number of results included on a page. Used for pagination with query',
        required => '0',
    },
    'offset' => {
        data_type => 'int',
        description => 'Where to start the listing(the offset of the first result). Used for pagination with limit',
        required => '0',
    },
    'order' => {
        data_type => 'string',
        description => 'The field by which to order. Default varies by endpoint/resource.',
        required => '0',
    },
    'order_direction' => {
        data_type => 'string',
        description => '',
        required => '0',
    },
    'institution' => {
        data_type => 'int',
        description => 'only return articles from this institution',
        required => '0',
    },
    'published_since' => {
        data_type => 'string',
        description => 'Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD',
        required => '0',
    },
    'modified_since' => {
        data_type => 'string',
        description => 'Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD',
        required => '0',
    },
    'group' => {
        data_type => 'int',
        description => 'only return articles from this group',
        required => '0',
    },
    'resource_doi' => {
        data_type => 'string',
        description => 'only return articles with this resource_doi',
        required => '0',
    },
    'item_type' => {
        data_type => 'int',
        description => 'Only return articles with the respective type. Mapping for item_type is: 1 - Figure, 2 - Media, 3 - Dataset, 5 - Poster, 6 - Journal contribution, 7 - Presentation, 8 - Thesis, 9 - Software, 11 - Online resource, 12 - Preprint, 13 - Book, 14 - Conference contribution, 15 - Chapter, 16 - Peer review, 17 - Educational resource, 18 - Report, 19 - Standard, 20 - Composition, 21 - Funding, 22 - Physical object, 23 - Data management plan, 24 - Workflow, 25 - Monograph, 26 - Performance, 27 - Event, 28 - Service, 29 - Model',
        required => '0',
    },
    'doi' => {
        data_type => 'string',
        description => 'only return articles with this doi',
        required => '0',
    },
    'handle' => {
        data_type => 'string',
        description => 'only return articles with this handle',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'articles_list' } = { 
    	summary => 'Public Articles',
        params => $params,
        returns => 'ARRAY[Article]',
        };
}
# @return ARRAY[Article]
#
sub articles_list {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/articles';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # query params
    if ( exists $args{'page'}) {
        $query_params->{'page'} = $self->{api_client}->to_query_value($args{'page'});
    }

    # query params
    if ( exists $args{'page_size'}) {
        $query_params->{'page_size'} = $self->{api_client}->to_query_value($args{'page_size'});
    }

    # query params
    if ( exists $args{'limit'}) {
        $query_params->{'limit'} = $self->{api_client}->to_query_value($args{'limit'});
    }

    # query params
    if ( exists $args{'offset'}) {
        $query_params->{'offset'} = $self->{api_client}->to_query_value($args{'offset'});
    }

    # query params
    if ( exists $args{'order'}) {
        $query_params->{'order'} = $self->{api_client}->to_query_value($args{'order'});
    }

    # query params
    if ( exists $args{'order_direction'}) {
        $query_params->{'order_direction'} = $self->{api_client}->to_query_value($args{'order_direction'});
    }

    # query params
    if ( exists $args{'institution'}) {
        $query_params->{'institution'} = $self->{api_client}->to_query_value($args{'institution'});
    }

    # query params
    if ( exists $args{'published_since'}) {
        $query_params->{'published_since'} = $self->{api_client}->to_query_value($args{'published_since'});
    }

    # query params
    if ( exists $args{'modified_since'}) {
        $query_params->{'modified_since'} = $self->{api_client}->to_query_value($args{'modified_since'});
    }

    # query params
    if ( exists $args{'group'}) {
        $query_params->{'group'} = $self->{api_client}->to_query_value($args{'group'});
    }

    # query params
    if ( exists $args{'resource_doi'}) {
        $query_params->{'resource_doi'} = $self->{api_client}->to_query_value($args{'resource_doi'});
    }

    # query params
    if ( exists $args{'item_type'}) {
        $query_params->{'item_type'} = $self->{api_client}->to_query_value($args{'item_type'});
    }

    # query params
    if ( exists $args{'doi'}) {
        $query_params->{'doi'} = $self->{api_client}->to_query_value($args{'doi'});
    }

    # query params
    if ( exists $args{'handle'}) {
        $query_params->{'handle'} = $self->{api_client}->to_query_value($args{'handle'});
    }

    # header params
    if ( exists $args{'x_cursor'}) {
        $header_params->{'X-Cursor'} = $self->{api_client}->to_header_value($args{'x_cursor'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Article]', $response);
    return $_response_object;
}

#
# articles_search
#
# Public Articles Search
# 
# @param UUID $x_cursor Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)
# @param ArticleSearch $search Search Parameters (optional)
{
    my $params = {
    'x_cursor' => {
        data_type => 'UUID',
        description => 'Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected.',
        required => '0',
    },
    'search' => {
        data_type => 'ArticleSearch',
        description => 'Search Parameters',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'articles_search' } = { 
    	summary => 'Public Articles Search',
        params => $params,
        returns => 'ARRAY[ArticleWithProject]',
        };
}
# @return ARRAY[ArticleWithProject]
#
sub articles_search {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/articles/search';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # header params
    if ( exists $args{'x_cursor'}) {
        $header_params->{'X-Cursor'} = $self->{api_client}->to_header_value($args{'x_cursor'});
    }

    my $_body_data;
    # body params
    if ( exists $args{'search'}) {
        $_body_data = $args{'search'};
    }

    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[ArticleWithProject]', $response);
    return $_response_object;
}

#
# private_article_author_delete
#
# Delete article author
# 
# @param int $article_id Article unique identifier (required)
# @param int $author_id Article Author unique identifier (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    'author_id' => {
        data_type => 'int',
        description => 'Article Author unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_author_delete' } = { 
    	summary => 'Delete article author',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_article_author_delete {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_author_delete");
    }

    # verify the required parameter 'author_id' is set
    unless (exists $args{'author_id'}) {
      croak("Missing the required parameter 'author_id' when calling private_article_author_delete");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}/authors/{author_id}';

    my $_method = 'DELETE';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'author_id'}) {
        my $_base_variable = "{" . "author_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'author_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_article_authors_add
#
# Add article authors
# 
# @param int $article_id Article unique identifier (required)
# @param AuthorsCreator $authors Authors description (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    'authors' => {
        data_type => 'AuthorsCreator',
        description => 'Authors description',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_authors_add' } = { 
    	summary => 'Add article authors',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_article_authors_add {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_authors_add");
    }

    # verify the required parameter 'authors' is set
    unless (exists $args{'authors'}) {
      croak("Missing the required parameter 'authors' when calling private_article_authors_add");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}/authors';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'authors'}) {
        $_body_data = $args{'authors'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_article_authors_list
#
# List article authors
# 
# @param int $article_id Article unique identifier (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_authors_list' } = { 
    	summary => 'List article authors',
        params => $params,
        returns => 'ARRAY[Author]',
        };
}
# @return ARRAY[Author]
#
sub private_article_authors_list {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_authors_list");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}/authors';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Author]', $response);
    return $_response_object;
}

#
# private_article_authors_replace
#
# Replace article authors
# 
# @param int $article_id Article unique identifier (required)
# @param AuthorsCreator $authors Authors description (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    'authors' => {
        data_type => 'AuthorsCreator',
        description => 'Authors description',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_authors_replace' } = { 
    	summary => 'Replace article authors',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_article_authors_replace {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_authors_replace");
    }

    # verify the required parameter 'authors' is set
    unless (exists $args{'authors'}) {
      croak("Missing the required parameter 'authors' when calling private_article_authors_replace");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}/authors';

    my $_method = 'PUT';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'authors'}) {
        $_body_data = $args{'authors'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_article_categories_add
#
# Add article categories
# 
# @param int $article_id Article unique identifier (required)
# @param CategoriesCreator $categories  (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    'categories' => {
        data_type => 'CategoriesCreator',
        description => '',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_categories_add' } = { 
    	summary => 'Add article categories',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_article_categories_add {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_categories_add");
    }

    # verify the required parameter 'categories' is set
    unless (exists $args{'categories'}) {
      croak("Missing the required parameter 'categories' when calling private_article_categories_add");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}/categories';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'categories'}) {
        $_body_data = $args{'categories'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_article_categories_list
#
# List article categories
# 
# @param int $article_id Article unique identifier (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_categories_list' } = { 
    	summary => 'List article categories',
        params => $params,
        returns => 'ARRAY[Category]',
        };
}
# @return ARRAY[Category]
#
sub private_article_categories_list {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_categories_list");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}/categories';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Category]', $response);
    return $_response_object;
}

#
# private_article_categories_replace
#
# Replace article categories
# 
# @param int $article_id Article unique identifier (required)
# @param CategoriesCreator $categories  (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    'categories' => {
        data_type => 'CategoriesCreator',
        description => '',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_categories_replace' } = { 
    	summary => 'Replace article categories',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_article_categories_replace {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_categories_replace");
    }

    # verify the required parameter 'categories' is set
    unless (exists $args{'categories'}) {
      croak("Missing the required parameter 'categories' when calling private_article_categories_replace");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}/categories';

    my $_method = 'PUT';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'categories'}) {
        $_body_data = $args{'categories'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_article_category_delete
#
# Delete article category
# 
# @param int $article_id Article unique identifier (required)
# @param int $category_id Category unique identifier (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    'category_id' => {
        data_type => 'int',
        description => 'Category unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_category_delete' } = { 
    	summary => 'Delete article category',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_article_category_delete {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_category_delete");
    }

    # verify the required parameter 'category_id' is set
    unless (exists $args{'category_id'}) {
      croak("Missing the required parameter 'category_id' when calling private_article_category_delete");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}/categories/{category_id}';

    my $_method = 'DELETE';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'category_id'}) {
        my $_base_variable = "{" . "category_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'category_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_article_confidentiality_delete
#
# Delete article confidentiality
# 
# @param int $article_id Article unique identifier (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_confidentiality_delete' } = { 
    	summary => 'Delete article confidentiality',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_article_confidentiality_delete {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_confidentiality_delete");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}/confidentiality';

    my $_method = 'DELETE';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_article_confidentiality_details
#
# Article confidentiality details
# 
# @param int $article_id Article unique identifier (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_confidentiality_details' } = { 
    	summary => 'Article confidentiality details',
        params => $params,
        returns => 'ArticleConfidentiality',
        };
}
# @return ArticleConfidentiality
#
sub private_article_confidentiality_details {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_confidentiality_details");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}/confidentiality';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ArticleConfidentiality', $response);
    return $_response_object;
}

#
# private_article_confidentiality_update
#
# Update article confidentiality
# 
# @param int $article_id Article unique identifier (required)
# @param ConfidentialityCreator $reason  (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    'reason' => {
        data_type => 'ConfidentialityCreator',
        description => '',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_confidentiality_update' } = { 
    	summary => 'Update article confidentiality',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_article_confidentiality_update {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_confidentiality_update");
    }

    # verify the required parameter 'reason' is set
    unless (exists $args{'reason'}) {
      croak("Missing the required parameter 'reason' when calling private_article_confidentiality_update");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}/confidentiality';

    my $_method = 'PUT';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'reason'}) {
        $_body_data = $args{'reason'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_article_create
#
# Create new Article
# 
# @param ArticleCreate $article Article description (required)
{
    my $params = {
    'article' => {
        data_type => 'ArticleCreate',
        description => 'Article description',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_create' } = { 
    	summary => 'Create new Article',
        params => $params,
        returns => 'LocationWarnings',
        };
}
# @return LocationWarnings
#
sub private_article_create {
    my ($self, %args) = @_;

    # verify the required parameter 'article' is set
    unless (exists $args{'article'}) {
      croak("Missing the required parameter 'article' when calling private_article_create");
    }

    # parse inputs
    my $_resource_path = '/account/articles';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    my $_body_data;
    # body params
    if ( exists $args{'article'}) {
        $_body_data = $args{'article'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('LocationWarnings', $response);
    return $_response_object;
}

#
# private_article_delete
#
# Delete article
# 
# @param int $article_id Article unique identifier (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_delete' } = { 
    	summary => 'Delete article',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_article_delete {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_delete");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}';

    my $_method = 'DELETE';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_article_details
#
# Article details
# 
# @param int $article_id Article unique identifier (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_details' } = { 
    	summary => 'Article details',
        params => $params,
        returns => 'ArticleCompletePrivate',
        };
}
# @return ArticleCompletePrivate
#
sub private_article_details {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_details");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ArticleCompletePrivate', $response);
    return $_response_object;
}

#
# private_article_embargo_delete
#
# Delete Article Embargo
# 
# @param int $article_id Article unique identifier (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_embargo_delete' } = { 
    	summary => 'Delete Article Embargo',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_article_embargo_delete {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_embargo_delete");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}/embargo';

    my $_method = 'DELETE';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_article_embargo_details
#
# Article Embargo Details
# 
# @param int $article_id Article unique identifier (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_embargo_details' } = { 
    	summary => 'Article Embargo Details',
        params => $params,
        returns => 'ArticleEmbargo',
        };
}
# @return ArticleEmbargo
#
sub private_article_embargo_details {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_embargo_details");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}/embargo';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ArticleEmbargo', $response);
    return $_response_object;
}

#
# private_article_embargo_update
#
# Update Article Embargo
# 
# @param int $article_id Article unique identifier (required)
# @param ArticleEmbargoUpdater $embargo Embargo description (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    'embargo' => {
        data_type => 'ArticleEmbargoUpdater',
        description => 'Embargo description',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_embargo_update' } = { 
    	summary => 'Update Article Embargo',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_article_embargo_update {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_embargo_update");
    }

    # verify the required parameter 'embargo' is set
    unless (exists $args{'embargo'}) {
      croak("Missing the required parameter 'embargo' when calling private_article_embargo_update");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}/embargo';

    my $_method = 'PUT';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'embargo'}) {
        $_body_data = $args{'embargo'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_article_file
#
# Single File
# 
# @param int $article_id Article unique identifier (required)
# @param int $file_id File unique identifier (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    'file_id' => {
        data_type => 'int',
        description => 'File unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_file' } = { 
    	summary => 'Single File',
        params => $params,
        returns => 'PrivateFile',
        };
}
# @return PrivateFile
#
sub private_article_file {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_file");
    }

    # verify the required parameter 'file_id' is set
    unless (exists $args{'file_id'}) {
      croak("Missing the required parameter 'file_id' when calling private_article_file");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}/files/{file_id}';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'file_id'}) {
        my $_base_variable = "{" . "file_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'file_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('PrivateFile', $response);
    return $_response_object;
}

#
# private_article_file_delete
#
# File Delete
# 
# @param int $article_id Article unique identifier (required)
# @param int $file_id File unique identifier (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    'file_id' => {
        data_type => 'int',
        description => 'File unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_file_delete' } = { 
    	summary => 'File Delete',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_article_file_delete {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_file_delete");
    }

    # verify the required parameter 'file_id' is set
    unless (exists $args{'file_id'}) {
      croak("Missing the required parameter 'file_id' when calling private_article_file_delete");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}/files/{file_id}';

    my $_method = 'DELETE';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'file_id'}) {
        my $_base_variable = "{" . "file_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'file_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_article_files_list
#
# List article files
# 
# @param int $article_id Article unique identifier (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_files_list' } = { 
    	summary => 'List article files',
        params => $params,
        returns => 'ARRAY[PrivateFile]',
        };
}
# @return ARRAY[PrivateFile]
#
sub private_article_files_list {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_files_list");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}/files';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[PrivateFile]', $response);
    return $_response_object;
}

#
# private_article_private_link
#
# List private links
# 
# @param int $article_id Article unique identifier (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_private_link' } = { 
    	summary => 'List private links',
        params => $params,
        returns => 'ARRAY[PrivateLink]',
        };
}
# @return ARRAY[PrivateLink]
#
sub private_article_private_link {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_private_link");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}/private_links';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[PrivateLink]', $response);
    return $_response_object;
}

#
# private_article_private_link_create
#
# Create private link
# 
# @param int $article_id Article unique identifier (required)
# @param PrivateLinkCreator $private_link  (optional)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    'private_link' => {
        data_type => 'PrivateLinkCreator',
        description => '',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_private_link_create' } = { 
    	summary => 'Create private link',
        params => $params,
        returns => 'PrivateLinkResponse',
        };
}
# @return PrivateLinkResponse
#
sub private_article_private_link_create {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_private_link_create");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}/private_links';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'private_link'}) {
        $_body_data = $args{'private_link'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('PrivateLinkResponse', $response);
    return $_response_object;
}

#
# private_article_private_link_delete
#
# Disable private link
# 
# @param int $article_id Article unique identifier (required)
# @param string $link_id Private link token (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    'link_id' => {
        data_type => 'string',
        description => 'Private link token',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_private_link_delete' } = { 
    	summary => 'Disable private link',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_article_private_link_delete {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_private_link_delete");
    }

    # verify the required parameter 'link_id' is set
    unless (exists $args{'link_id'}) {
      croak("Missing the required parameter 'link_id' when calling private_article_private_link_delete");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}/private_links/{link_id}';

    my $_method = 'DELETE';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'link_id'}) {
        my $_base_variable = "{" . "link_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'link_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_article_private_link_update
#
# Update private link
# 
# @param int $article_id Article unique identifier (required)
# @param string $link_id Private link token (required)
# @param PrivateLinkCreator $private_link  (optional)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    'link_id' => {
        data_type => 'string',
        description => 'Private link token',
        required => '1',
    },
    'private_link' => {
        data_type => 'PrivateLinkCreator',
        description => '',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_private_link_update' } = { 
    	summary => 'Update private link',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_article_private_link_update {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_private_link_update");
    }

    # verify the required parameter 'link_id' is set
    unless (exists $args{'link_id'}) {
      croak("Missing the required parameter 'link_id' when calling private_article_private_link_update");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}/private_links/{link_id}';

    my $_method = 'PUT';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'link_id'}) {
        my $_base_variable = "{" . "link_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'link_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'private_link'}) {
        $_body_data = $args{'private_link'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_article_publish
#
# Private Article Publish
# 
# @param int $article_id Article unique identifier (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_publish' } = { 
    	summary => 'Private Article Publish',
        params => $params,
        returns => 'Location',
        };
}
# @return Location
#
sub private_article_publish {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_publish");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}/publish';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('Location', $response);
    return $_response_object;
}

#
# private_article_reserve_doi
#
# Private Article Reserve DOI
# 
# @param int $article_id Article unique identifier (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_reserve_doi' } = { 
    	summary => 'Private Article Reserve DOI',
        params => $params,
        returns => 'ArticleDOI',
        };
}
# @return ArticleDOI
#
sub private_article_reserve_doi {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_reserve_doi");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}/reserve_doi';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ArticleDOI', $response);
    return $_response_object;
}

#
# private_article_reserve_handle
#
# Private Article Reserve Handle
# 
# @param int $article_id Article unique identifier (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_reserve_handle' } = { 
    	summary => 'Private Article Reserve Handle',
        params => $params,
        returns => 'ArticleHandle',
        };
}
# @return ArticleHandle
#
sub private_article_reserve_handle {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_reserve_handle");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}/reserve_handle';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ArticleHandle', $response);
    return $_response_object;
}

#
# private_article_resource
#
# Private Article Resource
# 
# @param int $article_id Article unique identifier (required)
# @param Resource $resource Resource data (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    'resource' => {
        data_type => 'Resource',
        description => 'Resource data',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_resource' } = { 
    	summary => 'Private Article Resource',
        params => $params,
        returns => 'Location',
        };
}
# @return Location
#
sub private_article_resource {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_resource");
    }

    # verify the required parameter 'resource' is set
    unless (exists $args{'resource'}) {
      croak("Missing the required parameter 'resource' when calling private_article_resource");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}/resource';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'resource'}) {
        $_body_data = $args{'resource'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('Location', $response);
    return $_response_object;
}

#
# private_article_update
#
# Update article
# 
# @param int $article_id Article unique identifier (required)
# @param ArticleUpdate $article Article description (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    'article' => {
        data_type => 'ArticleUpdate',
        description => 'Article description',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_update' } = { 
    	summary => 'Update article',
        params => $params,
        returns => 'LocationWarningsUpdate',
        };
}
# @return LocationWarningsUpdate
#
sub private_article_update {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_update");
    }

    # verify the required parameter 'article' is set
    unless (exists $args{'article'}) {
      croak("Missing the required parameter 'article' when calling private_article_update");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}';

    my $_method = 'PUT';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'article'}) {
        $_body_data = $args{'article'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('LocationWarningsUpdate', $response);
    return $_response_object;
}

#
# private_article_upload_complete
#
# Complete Upload
# 
# @param int $article_id Article unique identifier (required)
# @param int $file_id File unique identifier (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    'file_id' => {
        data_type => 'int',
        description => 'File unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_upload_complete' } = { 
    	summary => 'Complete Upload',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_article_upload_complete {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_upload_complete");
    }

    # verify the required parameter 'file_id' is set
    unless (exists $args{'file_id'}) {
      croak("Missing the required parameter 'file_id' when calling private_article_upload_complete");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}/files/{file_id}';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'file_id'}) {
        my $_base_variable = "{" . "file_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'file_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_article_upload_initiate
#
# Initiate Upload
# 
# @param int $article_id Article unique identifier (required)
# @param FileCreator $file  (required)
{
    my $params = {
    'article_id' => {
        data_type => 'int',
        description => 'Article unique identifier',
        required => '1',
    },
    'file' => {
        data_type => 'FileCreator',
        description => '',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_article_upload_initiate' } = { 
    	summary => 'Initiate Upload',
        params => $params,
        returns => 'Location',
        };
}
# @return Location
#
sub private_article_upload_initiate {
    my ($self, %args) = @_;

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_article_upload_initiate");
    }

    # verify the required parameter 'file' is set
    unless (exists $args{'file'}) {
      croak("Missing the required parameter 'file' when calling private_article_upload_initiate");
    }

    # parse inputs
    my $_resource_path = '/account/articles/{article_id}/files';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'file'}) {
        $_body_data = $args{'file'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('Location', $response);
    return $_response_object;
}

#
# private_articles_list
#
# Private Articles
# 
# @param int $page Page number. Used for pagination with page_size (optional)
# @param int $page_size The number of results included on a page. Used for pagination with page (optional, default to 10)
# @param int $limit Number of results included on a page. Used for pagination with query (optional)
# @param int $offset Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
{
    my $params = {
    'page' => {
        data_type => 'int',
        description => 'Page number. Used for pagination with page_size',
        required => '0',
    },
    'page_size' => {
        data_type => 'int',
        description => 'The number of results included on a page. Used for pagination with page',
        required => '0',
    },
    'limit' => {
        data_type => 'int',
        description => 'Number of results included on a page. Used for pagination with query',
        required => '0',
    },
    'offset' => {
        data_type => 'int',
        description => 'Where to start the listing(the offset of the first result). Used for pagination with limit',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_articles_list' } = { 
    	summary => 'Private Articles',
        params => $params,
        returns => 'ARRAY[Article]',
        };
}
# @return ARRAY[Article]
#
sub private_articles_list {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/account/articles';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # query params
    if ( exists $args{'page'}) {
        $query_params->{'page'} = $self->{api_client}->to_query_value($args{'page'});
    }

    # query params
    if ( exists $args{'page_size'}) {
        $query_params->{'page_size'} = $self->{api_client}->to_query_value($args{'page_size'});
    }

    # query params
    if ( exists $args{'limit'}) {
        $query_params->{'limit'} = $self->{api_client}->to_query_value($args{'limit'});
    }

    # query params
    if ( exists $args{'offset'}) {
        $query_params->{'offset'} = $self->{api_client}->to_query_value($args{'offset'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Article]', $response);
    return $_response_object;
}

#
# private_articles_search
#
# Private Articles search
# 
# @param PrivateArticleSearch $search Search Parameters (required)
{
    my $params = {
    'search' => {
        data_type => 'PrivateArticleSearch',
        description => 'Search Parameters',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_articles_search' } = { 
    	summary => 'Private Articles search',
        params => $params,
        returns => 'ARRAY[ArticleWithProject]',
        };
}
# @return ARRAY[ArticleWithProject]
#
sub private_articles_search {
    my ($self, %args) = @_;

    # verify the required parameter 'search' is set
    unless (exists $args{'search'}) {
      croak("Missing the required parameter 'search' when calling private_articles_search");
    }

    # parse inputs
    my $_resource_path = '/account/articles/search';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    my $_body_data;
    # body params
    if ( exists $args{'search'}) {
        $_body_data = $args{'search'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[ArticleWithProject]', $response);
    return $_response_object;
}

1;
