=begin comment

Figshare API

Figshare apiv2. Using Swagger 2.0

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git

=end comment

=cut

#
# NOTE: This class is auto generated by the swagger code generator program. 
# Do not edit the class manually.
# Ref: https://github.com/swagger-api/swagger-codegen
#
package WWW::SwaggerClient::AuthorsApi;

require 5.6.0;
use strict;
use warnings;
use utf8; 
use Exporter;
use Carp qw( croak );
use Log::Any qw($log);

use WWW::SwaggerClient::ApiClient;

use base "Class::Data::Inheritable";

__PACKAGE__->mk_classdata('method_documentation' => {});

sub new {
    my $class = shift;
    my $api_client;

    if ($_[0] && ref $_[0] && ref $_[0] eq 'WWW::SwaggerClient::ApiClient' ) {
        $api_client = $_[0];
    } else {
        $api_client = WWW::SwaggerClient::ApiClient->new(@_);
    }

    bless { api_client => $api_client }, $class;

}


#
# private_author_details
#
# Author details
# 
# @param int $author_id Author unique identifier (required)
{
    my $params = {
    'author_id' => {
        data_type => 'int',
        description => 'Author unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_author_details' } = { 
    	summary => 'Author details',
        params => $params,
        returns => 'AuthorComplete',
        };
}
# @return AuthorComplete
#
sub private_author_details {
    my ($self, %args) = @_;

    # verify the required parameter 'author_id' is set
    unless (exists $args{'author_id'}) {
      croak("Missing the required parameter 'author_id' when calling private_author_details");
    }

    # parse inputs
    my $_resource_path = '/account/authors/{author_id}';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'author_id'}) {
        my $_base_variable = "{" . "author_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'author_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('AuthorComplete', $response);
    return $_response_object;
}

#
# private_authors_search
#
# Search Authors
# 
# @param PrivateAuthorsSearch $search Search Parameters (optional)
{
    my $params = {
    'search' => {
        data_type => 'PrivateAuthorsSearch',
        description => 'Search Parameters',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_authors_search' } = { 
    	summary => 'Search Authors',
        params => $params,
        returns => 'ARRAY[Author]',
        };
}
# @return ARRAY[Author]
#
sub private_authors_search {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/account/authors/search';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    my $_body_data;
    # body params
    if ( exists $args{'search'}) {
        $_body_data = $args{'search'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Author]', $response);
    return $_response_object;
}

1;
