=begin comment

Figshare API

Figshare apiv2. Using Swagger 2.0

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git

=end comment

=cut

#
# NOTE: This class is auto generated by the swagger code generator program. 
# Do not edit the class manually.
# Ref: https://github.com/swagger-api/swagger-codegen
#
package WWW::SwaggerClient::CollectionsApi;

require 5.6.0;
use strict;
use warnings;
use utf8; 
use Exporter;
use Carp qw( croak );
use Log::Any qw($log);

use WWW::SwaggerClient::ApiClient;

use base "Class::Data::Inheritable";

__PACKAGE__->mk_classdata('method_documentation' => {});

sub new {
    my $class = shift;
    my $api_client;

    if ($_[0] && ref $_[0] && ref $_[0] eq 'WWW::SwaggerClient::ApiClient' ) {
        $api_client = $_[0];
    } else {
        $api_client = WWW::SwaggerClient::ApiClient->new(@_);
    }

    bless { api_client => $api_client }, $class;

}


#
# collection_articles
#
# Public Collection Articles
# 
# @param int $collection_id Collection Unique identifier (required)
# @param int $page Page number. Used for pagination with page_size (optional)
# @param int $page_size The number of results included on a page. Used for pagination with page (optional, default to 10)
# @param int $limit Number of results included on a page. Used for pagination with query (optional)
# @param int $offset Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
{
    my $params = {
    'collection_id' => {
        data_type => 'int',
        description => 'Collection Unique identifier',
        required => '1',
    },
    'page' => {
        data_type => 'int',
        description => 'Page number. Used for pagination with page_size',
        required => '0',
    },
    'page_size' => {
        data_type => 'int',
        description => 'The number of results included on a page. Used for pagination with page',
        required => '0',
    },
    'limit' => {
        data_type => 'int',
        description => 'Number of results included on a page. Used for pagination with query',
        required => '0',
    },
    'offset' => {
        data_type => 'int',
        description => 'Where to start the listing(the offset of the first result). Used for pagination with limit',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'collection_articles' } = { 
    	summary => 'Public Collection Articles',
        params => $params,
        returns => 'ARRAY[Article]',
        };
}
# @return ARRAY[Article]
#
sub collection_articles {
    my ($self, %args) = @_;

    # verify the required parameter 'collection_id' is set
    unless (exists $args{'collection_id'}) {
      croak("Missing the required parameter 'collection_id' when calling collection_articles");
    }

    # parse inputs
    my $_resource_path = '/collections/{collection_id}/articles';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # query params
    if ( exists $args{'page'}) {
        $query_params->{'page'} = $self->{api_client}->to_query_value($args{'page'});
    }

    # query params
    if ( exists $args{'page_size'}) {
        $query_params->{'page_size'} = $self->{api_client}->to_query_value($args{'page_size'});
    }

    # query params
    if ( exists $args{'limit'}) {
        $query_params->{'limit'} = $self->{api_client}->to_query_value($args{'limit'});
    }

    # query params
    if ( exists $args{'offset'}) {
        $query_params->{'offset'} = $self->{api_client}->to_query_value($args{'offset'});
    }

    # path params
    if ( exists $args{'collection_id'}) {
        my $_base_variable = "{" . "collection_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'collection_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Article]', $response);
    return $_response_object;
}

#
# collection_details
#
# Collection details
# 
# @param int $collection_id Collection Unique identifier (required)
{
    my $params = {
    'collection_id' => {
        data_type => 'int',
        description => 'Collection Unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'collection_details' } = { 
    	summary => 'Collection details',
        params => $params,
        returns => 'CollectionComplete',
        };
}
# @return CollectionComplete
#
sub collection_details {
    my ($self, %args) = @_;

    # verify the required parameter 'collection_id' is set
    unless (exists $args{'collection_id'}) {
      croak("Missing the required parameter 'collection_id' when calling collection_details");
    }

    # parse inputs
    my $_resource_path = '/collections/{collection_id}';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'collection_id'}) {
        my $_base_variable = "{" . "collection_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'collection_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('CollectionComplete', $response);
    return $_response_object;
}

#
# collection_version_details
#
# Collection Version details
# 
# @param int $collection_id Collection Unique identifier (required)
# @param int $version_id Version Number (required)
{
    my $params = {
    'collection_id' => {
        data_type => 'int',
        description => 'Collection Unique identifier',
        required => '1',
    },
    'version_id' => {
        data_type => 'int',
        description => 'Version Number',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'collection_version_details' } = { 
    	summary => 'Collection Version details',
        params => $params,
        returns => 'CollectionComplete',
        };
}
# @return CollectionComplete
#
sub collection_version_details {
    my ($self, %args) = @_;

    # verify the required parameter 'collection_id' is set
    unless (exists $args{'collection_id'}) {
      croak("Missing the required parameter 'collection_id' when calling collection_version_details");
    }

    # verify the required parameter 'version_id' is set
    unless (exists $args{'version_id'}) {
      croak("Missing the required parameter 'version_id' when calling collection_version_details");
    }

    # parse inputs
    my $_resource_path = '/collections/{collection_id}/versions/{version_id}';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'collection_id'}) {
        my $_base_variable = "{" . "collection_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'collection_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'version_id'}) {
        my $_base_variable = "{" . "version_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'version_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('CollectionComplete', $response);
    return $_response_object;
}

#
# collection_versions
#
# Collection Versions list
# 
# @param int $collection_id Collection Unique identifier (required)
{
    my $params = {
    'collection_id' => {
        data_type => 'int',
        description => 'Collection Unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'collection_versions' } = { 
    	summary => 'Collection Versions list',
        params => $params,
        returns => 'ARRAY[CollectionVersions]',
        };
}
# @return ARRAY[CollectionVersions]
#
sub collection_versions {
    my ($self, %args) = @_;

    # verify the required parameter 'collection_id' is set
    unless (exists $args{'collection_id'}) {
      croak("Missing the required parameter 'collection_id' when calling collection_versions");
    }

    # parse inputs
    my $_resource_path = '/collections/{collection_id}/versions';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'collection_id'}) {
        my $_base_variable = "{" . "collection_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'collection_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[CollectionVersions]', $response);
    return $_response_object;
}

#
# collections_list
#
# Public Collections
# 
# @param UUID $x_cursor Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)
# @param int $page Page number. Used for pagination with page_size (optional)
# @param int $page_size The number of results included on a page. Used for pagination with page (optional, default to 10)
# @param int $limit Number of results included on a page. Used for pagination with query (optional)
# @param int $offset Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
# @param string $order The field by which to order. Default varies by endpoint/resource. (optional, default to published_date)
# @param string $order_direction  (optional, default to desc)
# @param int $institution only return collections from this institution (optional)
# @param string $published_since Filter by collection publishing date. Will only return collections published after the date. date(ISO 8601) YYYY-MM-DD (optional)
# @param string $modified_since Filter by collection modified date. Will only return collections published after the date. date(ISO 8601) YYYY-MM-DD (optional)
# @param int $group only return collections from this group (optional)
# @param string $resource_doi only return collections with this resource_doi (optional)
# @param string $doi only return collections with this doi (optional)
# @param string $handle only return collections with this handle (optional)
{
    my $params = {
    'x_cursor' => {
        data_type => 'UUID',
        description => 'Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected.',
        required => '0',
    },
    'page' => {
        data_type => 'int',
        description => 'Page number. Used for pagination with page_size',
        required => '0',
    },
    'page_size' => {
        data_type => 'int',
        description => 'The number of results included on a page. Used for pagination with page',
        required => '0',
    },
    'limit' => {
        data_type => 'int',
        description => 'Number of results included on a page. Used for pagination with query',
        required => '0',
    },
    'offset' => {
        data_type => 'int',
        description => 'Where to start the listing(the offset of the first result). Used for pagination with limit',
        required => '0',
    },
    'order' => {
        data_type => 'string',
        description => 'The field by which to order. Default varies by endpoint/resource.',
        required => '0',
    },
    'order_direction' => {
        data_type => 'string',
        description => '',
        required => '0',
    },
    'institution' => {
        data_type => 'int',
        description => 'only return collections from this institution',
        required => '0',
    },
    'published_since' => {
        data_type => 'string',
        description => 'Filter by collection publishing date. Will only return collections published after the date. date(ISO 8601) YYYY-MM-DD',
        required => '0',
    },
    'modified_since' => {
        data_type => 'string',
        description => 'Filter by collection modified date. Will only return collections published after the date. date(ISO 8601) YYYY-MM-DD',
        required => '0',
    },
    'group' => {
        data_type => 'int',
        description => 'only return collections from this group',
        required => '0',
    },
    'resource_doi' => {
        data_type => 'string',
        description => 'only return collections with this resource_doi',
        required => '0',
    },
    'doi' => {
        data_type => 'string',
        description => 'only return collections with this doi',
        required => '0',
    },
    'handle' => {
        data_type => 'string',
        description => 'only return collections with this handle',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'collections_list' } = { 
    	summary => 'Public Collections',
        params => $params,
        returns => 'ARRAY[Collection]',
        };
}
# @return ARRAY[Collection]
#
sub collections_list {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/collections';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # query params
    if ( exists $args{'page'}) {
        $query_params->{'page'} = $self->{api_client}->to_query_value($args{'page'});
    }

    # query params
    if ( exists $args{'page_size'}) {
        $query_params->{'page_size'} = $self->{api_client}->to_query_value($args{'page_size'});
    }

    # query params
    if ( exists $args{'limit'}) {
        $query_params->{'limit'} = $self->{api_client}->to_query_value($args{'limit'});
    }

    # query params
    if ( exists $args{'offset'}) {
        $query_params->{'offset'} = $self->{api_client}->to_query_value($args{'offset'});
    }

    # query params
    if ( exists $args{'order'}) {
        $query_params->{'order'} = $self->{api_client}->to_query_value($args{'order'});
    }

    # query params
    if ( exists $args{'order_direction'}) {
        $query_params->{'order_direction'} = $self->{api_client}->to_query_value($args{'order_direction'});
    }

    # query params
    if ( exists $args{'institution'}) {
        $query_params->{'institution'} = $self->{api_client}->to_query_value($args{'institution'});
    }

    # query params
    if ( exists $args{'published_since'}) {
        $query_params->{'published_since'} = $self->{api_client}->to_query_value($args{'published_since'});
    }

    # query params
    if ( exists $args{'modified_since'}) {
        $query_params->{'modified_since'} = $self->{api_client}->to_query_value($args{'modified_since'});
    }

    # query params
    if ( exists $args{'group'}) {
        $query_params->{'group'} = $self->{api_client}->to_query_value($args{'group'});
    }

    # query params
    if ( exists $args{'resource_doi'}) {
        $query_params->{'resource_doi'} = $self->{api_client}->to_query_value($args{'resource_doi'});
    }

    # query params
    if ( exists $args{'doi'}) {
        $query_params->{'doi'} = $self->{api_client}->to_query_value($args{'doi'});
    }

    # query params
    if ( exists $args{'handle'}) {
        $query_params->{'handle'} = $self->{api_client}->to_query_value($args{'handle'});
    }

    # header params
    if ( exists $args{'x_cursor'}) {
        $header_params->{'X-Cursor'} = $self->{api_client}->to_header_value($args{'x_cursor'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Collection]', $response);
    return $_response_object;
}

#
# collections_search
#
# Public Collections Search
# 
# @param UUID $x_cursor Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)
# @param CollectionSearch $search Search Parameters (optional)
{
    my $params = {
    'x_cursor' => {
        data_type => 'UUID',
        description => 'Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected.',
        required => '0',
    },
    'search' => {
        data_type => 'CollectionSearch',
        description => 'Search Parameters',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'collections_search' } = { 
    	summary => 'Public Collections Search',
        params => $params,
        returns => 'ARRAY[Collection]',
        };
}
# @return ARRAY[Collection]
#
sub collections_search {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/collections/search';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # header params
    if ( exists $args{'x_cursor'}) {
        $header_params->{'X-Cursor'} = $self->{api_client}->to_header_value($args{'x_cursor'});
    }

    my $_body_data;
    # body params
    if ( exists $args{'search'}) {
        $_body_data = $args{'search'};
    }

    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Collection]', $response);
    return $_response_object;
}

#
# private_collection_article_delete
#
# Delete collection article
# 
# @param int $collection_id Collection unique identifier (required)
# @param int $article_id Collection article unique identifier (required)
{
    my $params = {
    'collection_id' => {
        data_type => 'int',
        description => 'Collection unique identifier',
        required => '1',
    },
    'article_id' => {
        data_type => 'int',
        description => 'Collection article unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_collection_article_delete' } = { 
    	summary => 'Delete collection article',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_collection_article_delete {
    my ($self, %args) = @_;

    # verify the required parameter 'collection_id' is set
    unless (exists $args{'collection_id'}) {
      croak("Missing the required parameter 'collection_id' when calling private_collection_article_delete");
    }

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_collection_article_delete");
    }

    # parse inputs
    my $_resource_path = '/account/collections/{collection_id}/articles/{article_id}';

    my $_method = 'DELETE';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'collection_id'}) {
        my $_base_variable = "{" . "collection_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'collection_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_collection_articles_add
#
# Add collection articles
# 
# @param int $collection_id Collection unique identifier (required)
# @param ArticlesCreator $articles Articles list (required)
{
    my $params = {
    'collection_id' => {
        data_type => 'int',
        description => 'Collection unique identifier',
        required => '1',
    },
    'articles' => {
        data_type => 'ArticlesCreator',
        description => 'Articles list',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_collection_articles_add' } = { 
    	summary => 'Add collection articles',
        params => $params,
        returns => 'Location',
        };
}
# @return Location
#
sub private_collection_articles_add {
    my ($self, %args) = @_;

    # verify the required parameter 'collection_id' is set
    unless (exists $args{'collection_id'}) {
      croak("Missing the required parameter 'collection_id' when calling private_collection_articles_add");
    }

    # verify the required parameter 'articles' is set
    unless (exists $args{'articles'}) {
      croak("Missing the required parameter 'articles' when calling private_collection_articles_add");
    }

    # parse inputs
    my $_resource_path = '/account/collections/{collection_id}/articles';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'collection_id'}) {
        my $_base_variable = "{" . "collection_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'collection_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'articles'}) {
        $_body_data = $args{'articles'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('Location', $response);
    return $_response_object;
}

#
# private_collection_articles_list
#
# List collection articles
# 
# @param int $collection_id Collection unique identifier (required)
# @param int $page Page number. Used for pagination with page_size (optional)
# @param int $page_size The number of results included on a page. Used for pagination with page (optional, default to 10)
# @param int $limit Number of results included on a page. Used for pagination with query (optional)
# @param int $offset Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
{
    my $params = {
    'collection_id' => {
        data_type => 'int',
        description => 'Collection unique identifier',
        required => '1',
    },
    'page' => {
        data_type => 'int',
        description => 'Page number. Used for pagination with page_size',
        required => '0',
    },
    'page_size' => {
        data_type => 'int',
        description => 'The number of results included on a page. Used for pagination with page',
        required => '0',
    },
    'limit' => {
        data_type => 'int',
        description => 'Number of results included on a page. Used for pagination with query',
        required => '0',
    },
    'offset' => {
        data_type => 'int',
        description => 'Where to start the listing(the offset of the first result). Used for pagination with limit',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_collection_articles_list' } = { 
    	summary => 'List collection articles',
        params => $params,
        returns => 'ARRAY[Article]',
        };
}
# @return ARRAY[Article]
#
sub private_collection_articles_list {
    my ($self, %args) = @_;

    # verify the required parameter 'collection_id' is set
    unless (exists $args{'collection_id'}) {
      croak("Missing the required parameter 'collection_id' when calling private_collection_articles_list");
    }

    # parse inputs
    my $_resource_path = '/account/collections/{collection_id}/articles';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # query params
    if ( exists $args{'page'}) {
        $query_params->{'page'} = $self->{api_client}->to_query_value($args{'page'});
    }

    # query params
    if ( exists $args{'page_size'}) {
        $query_params->{'page_size'} = $self->{api_client}->to_query_value($args{'page_size'});
    }

    # query params
    if ( exists $args{'limit'}) {
        $query_params->{'limit'} = $self->{api_client}->to_query_value($args{'limit'});
    }

    # query params
    if ( exists $args{'offset'}) {
        $query_params->{'offset'} = $self->{api_client}->to_query_value($args{'offset'});
    }

    # path params
    if ( exists $args{'collection_id'}) {
        my $_base_variable = "{" . "collection_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'collection_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Article]', $response);
    return $_response_object;
}

#
# private_collection_articles_replace
#
# Replace collection articles
# 
# @param int $collection_id Collection unique identifier (required)
# @param ArticlesCreator $articles Articles List (required)
{
    my $params = {
    'collection_id' => {
        data_type => 'int',
        description => 'Collection unique identifier',
        required => '1',
    },
    'articles' => {
        data_type => 'ArticlesCreator',
        description => 'Articles List',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_collection_articles_replace' } = { 
    	summary => 'Replace collection articles',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_collection_articles_replace {
    my ($self, %args) = @_;

    # verify the required parameter 'collection_id' is set
    unless (exists $args{'collection_id'}) {
      croak("Missing the required parameter 'collection_id' when calling private_collection_articles_replace");
    }

    # verify the required parameter 'articles' is set
    unless (exists $args{'articles'}) {
      croak("Missing the required parameter 'articles' when calling private_collection_articles_replace");
    }

    # parse inputs
    my $_resource_path = '/account/collections/{collection_id}/articles';

    my $_method = 'PUT';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'collection_id'}) {
        my $_base_variable = "{" . "collection_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'collection_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'articles'}) {
        $_body_data = $args{'articles'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_collection_author_delete
#
# Delete collection author
# 
# @param int $collection_id Collection unique identifier (required)
# @param int $author_id Collection Author unique identifier (required)
{
    my $params = {
    'collection_id' => {
        data_type => 'int',
        description => 'Collection unique identifier',
        required => '1',
    },
    'author_id' => {
        data_type => 'int',
        description => 'Collection Author unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_collection_author_delete' } = { 
    	summary => 'Delete collection author',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_collection_author_delete {
    my ($self, %args) = @_;

    # verify the required parameter 'collection_id' is set
    unless (exists $args{'collection_id'}) {
      croak("Missing the required parameter 'collection_id' when calling private_collection_author_delete");
    }

    # verify the required parameter 'author_id' is set
    unless (exists $args{'author_id'}) {
      croak("Missing the required parameter 'author_id' when calling private_collection_author_delete");
    }

    # parse inputs
    my $_resource_path = '/account/collections/{collection_id}/authors/{author_id}';

    my $_method = 'DELETE';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'collection_id'}) {
        my $_base_variable = "{" . "collection_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'collection_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'author_id'}) {
        my $_base_variable = "{" . "author_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'author_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_collection_authors_add
#
# Add collection authors
# 
# @param int $collection_id Collection unique identifier (required)
# @param AuthorsCreator $authors List of authors (required)
{
    my $params = {
    'collection_id' => {
        data_type => 'int',
        description => 'Collection unique identifier',
        required => '1',
    },
    'authors' => {
        data_type => 'AuthorsCreator',
        description => 'List of authors',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_collection_authors_add' } = { 
    	summary => 'Add collection authors',
        params => $params,
        returns => 'Location',
        };
}
# @return Location
#
sub private_collection_authors_add {
    my ($self, %args) = @_;

    # verify the required parameter 'collection_id' is set
    unless (exists $args{'collection_id'}) {
      croak("Missing the required parameter 'collection_id' when calling private_collection_authors_add");
    }

    # verify the required parameter 'authors' is set
    unless (exists $args{'authors'}) {
      croak("Missing the required parameter 'authors' when calling private_collection_authors_add");
    }

    # parse inputs
    my $_resource_path = '/account/collections/{collection_id}/authors';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'collection_id'}) {
        my $_base_variable = "{" . "collection_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'collection_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'authors'}) {
        $_body_data = $args{'authors'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('Location', $response);
    return $_response_object;
}

#
# private_collection_authors_list
#
# List collection authors
# 
# @param int $collection_id Collection unique identifier (required)
{
    my $params = {
    'collection_id' => {
        data_type => 'int',
        description => 'Collection unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_collection_authors_list' } = { 
    	summary => 'List collection authors',
        params => $params,
        returns => 'ARRAY[Author]',
        };
}
# @return ARRAY[Author]
#
sub private_collection_authors_list {
    my ($self, %args) = @_;

    # verify the required parameter 'collection_id' is set
    unless (exists $args{'collection_id'}) {
      croak("Missing the required parameter 'collection_id' when calling private_collection_authors_list");
    }

    # parse inputs
    my $_resource_path = '/account/collections/{collection_id}/authors';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'collection_id'}) {
        my $_base_variable = "{" . "collection_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'collection_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Author]', $response);
    return $_response_object;
}

#
# private_collection_authors_replace
#
# Replace collection authors
# 
# @param int $collection_id Collection unique identifier (required)
# @param AuthorsCreator $authors List of authors (required)
{
    my $params = {
    'collection_id' => {
        data_type => 'int',
        description => 'Collection unique identifier',
        required => '1',
    },
    'authors' => {
        data_type => 'AuthorsCreator',
        description => 'List of authors',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_collection_authors_replace' } = { 
    	summary => 'Replace collection authors',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_collection_authors_replace {
    my ($self, %args) = @_;

    # verify the required parameter 'collection_id' is set
    unless (exists $args{'collection_id'}) {
      croak("Missing the required parameter 'collection_id' when calling private_collection_authors_replace");
    }

    # verify the required parameter 'authors' is set
    unless (exists $args{'authors'}) {
      croak("Missing the required parameter 'authors' when calling private_collection_authors_replace");
    }

    # parse inputs
    my $_resource_path = '/account/collections/{collection_id}/authors';

    my $_method = 'PUT';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'collection_id'}) {
        my $_base_variable = "{" . "collection_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'collection_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'authors'}) {
        $_body_data = $args{'authors'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_collection_categories_add
#
# Add collection categories
# 
# @param int $collection_id Collection unique identifier (required)
# @param CategoriesCreator $categories Categories list (required)
{
    my $params = {
    'collection_id' => {
        data_type => 'int',
        description => 'Collection unique identifier',
        required => '1',
    },
    'categories' => {
        data_type => 'CategoriesCreator',
        description => 'Categories list',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_collection_categories_add' } = { 
    	summary => 'Add collection categories',
        params => $params,
        returns => 'Location',
        };
}
# @return Location
#
sub private_collection_categories_add {
    my ($self, %args) = @_;

    # verify the required parameter 'collection_id' is set
    unless (exists $args{'collection_id'}) {
      croak("Missing the required parameter 'collection_id' when calling private_collection_categories_add");
    }

    # verify the required parameter 'categories' is set
    unless (exists $args{'categories'}) {
      croak("Missing the required parameter 'categories' when calling private_collection_categories_add");
    }

    # parse inputs
    my $_resource_path = '/account/collections/{collection_id}/categories';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'collection_id'}) {
        my $_base_variable = "{" . "collection_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'collection_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'categories'}) {
        $_body_data = $args{'categories'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('Location', $response);
    return $_response_object;
}

#
# private_collection_categories_list
#
# List collection categories
# 
# @param int $collection_id Collection unique identifier (required)
{
    my $params = {
    'collection_id' => {
        data_type => 'int',
        description => 'Collection unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_collection_categories_list' } = { 
    	summary => 'List collection categories',
        params => $params,
        returns => 'ARRAY[Category]',
        };
}
# @return ARRAY[Category]
#
sub private_collection_categories_list {
    my ($self, %args) = @_;

    # verify the required parameter 'collection_id' is set
    unless (exists $args{'collection_id'}) {
      croak("Missing the required parameter 'collection_id' when calling private_collection_categories_list");
    }

    # parse inputs
    my $_resource_path = '/account/collections/{collection_id}/categories';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'collection_id'}) {
        my $_base_variable = "{" . "collection_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'collection_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Category]', $response);
    return $_response_object;
}

#
# private_collection_categories_replace
#
# Replace collection categories
# 
# @param int $collection_id Collection unique identifier (required)
# @param CategoriesCreator $categories Categories list (required)
{
    my $params = {
    'collection_id' => {
        data_type => 'int',
        description => 'Collection unique identifier',
        required => '1',
    },
    'categories' => {
        data_type => 'CategoriesCreator',
        description => 'Categories list',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_collection_categories_replace' } = { 
    	summary => 'Replace collection categories',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_collection_categories_replace {
    my ($self, %args) = @_;

    # verify the required parameter 'collection_id' is set
    unless (exists $args{'collection_id'}) {
      croak("Missing the required parameter 'collection_id' when calling private_collection_categories_replace");
    }

    # verify the required parameter 'categories' is set
    unless (exists $args{'categories'}) {
      croak("Missing the required parameter 'categories' when calling private_collection_categories_replace");
    }

    # parse inputs
    my $_resource_path = '/account/collections/{collection_id}/categories';

    my $_method = 'PUT';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'collection_id'}) {
        my $_base_variable = "{" . "collection_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'collection_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'categories'}) {
        $_body_data = $args{'categories'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_collection_category_delete
#
# Delete collection category
# 
# @param int $collection_id Collection unique identifier (required)
# @param int $category_id Collection category unique identifier (required)
{
    my $params = {
    'collection_id' => {
        data_type => 'int',
        description => 'Collection unique identifier',
        required => '1',
    },
    'category_id' => {
        data_type => 'int',
        description => 'Collection category unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_collection_category_delete' } = { 
    	summary => 'Delete collection category',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_collection_category_delete {
    my ($self, %args) = @_;

    # verify the required parameter 'collection_id' is set
    unless (exists $args{'collection_id'}) {
      croak("Missing the required parameter 'collection_id' when calling private_collection_category_delete");
    }

    # verify the required parameter 'category_id' is set
    unless (exists $args{'category_id'}) {
      croak("Missing the required parameter 'category_id' when calling private_collection_category_delete");
    }

    # parse inputs
    my $_resource_path = '/account/collections/{collection_id}/categories/{category_id}';

    my $_method = 'DELETE';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'collection_id'}) {
        my $_base_variable = "{" . "collection_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'collection_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'category_id'}) {
        my $_base_variable = "{" . "category_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'category_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_collection_create
#
# Create collection
# 
# @param CollectionCreate $collection Collection description (required)
{
    my $params = {
    'collection' => {
        data_type => 'CollectionCreate',
        description => 'Collection description',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_collection_create' } = { 
    	summary => 'Create collection',
        params => $params,
        returns => 'LocationWarnings',
        };
}
# @return LocationWarnings
#
sub private_collection_create {
    my ($self, %args) = @_;

    # verify the required parameter 'collection' is set
    unless (exists $args{'collection'}) {
      croak("Missing the required parameter 'collection' when calling private_collection_create");
    }

    # parse inputs
    my $_resource_path = '/account/collections';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    my $_body_data;
    # body params
    if ( exists $args{'collection'}) {
        $_body_data = $args{'collection'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('LocationWarnings', $response);
    return $_response_object;
}

#
# private_collection_delete
#
# Delete collection
# 
# @param int $collection_id Collection Unique identifier (required)
{
    my $params = {
    'collection_id' => {
        data_type => 'int',
        description => 'Collection Unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_collection_delete' } = { 
    	summary => 'Delete collection',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_collection_delete {
    my ($self, %args) = @_;

    # verify the required parameter 'collection_id' is set
    unless (exists $args{'collection_id'}) {
      croak("Missing the required parameter 'collection_id' when calling private_collection_delete");
    }

    # parse inputs
    my $_resource_path = '/account/collections/{collection_id}';

    my $_method = 'DELETE';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'collection_id'}) {
        my $_base_variable = "{" . "collection_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'collection_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_collection_details
#
# Collection details
# 
# @param int $collection_id Collection Unique identifier (required)
{
    my $params = {
    'collection_id' => {
        data_type => 'int',
        description => 'Collection Unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_collection_details' } = { 
    	summary => 'Collection details',
        params => $params,
        returns => 'CollectionCompletePrivate',
        };
}
# @return CollectionCompletePrivate
#
sub private_collection_details {
    my ($self, %args) = @_;

    # verify the required parameter 'collection_id' is set
    unless (exists $args{'collection_id'}) {
      croak("Missing the required parameter 'collection_id' when calling private_collection_details");
    }

    # parse inputs
    my $_resource_path = '/account/collections/{collection_id}';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'collection_id'}) {
        my $_base_variable = "{" . "collection_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'collection_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('CollectionCompletePrivate', $response);
    return $_response_object;
}

#
# private_collection_private_link_create
#
# Create collection private link
# 
# @param int $collection_id Collection unique identifier (required)
# @param CollectionPrivateLinkCreator $private_link  (optional)
{
    my $params = {
    'collection_id' => {
        data_type => 'int',
        description => 'Collection unique identifier',
        required => '1',
    },
    'private_link' => {
        data_type => 'CollectionPrivateLinkCreator',
        description => '',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_collection_private_link_create' } = { 
    	summary => 'Create collection private link',
        params => $params,
        returns => 'PrivateLinkResponse',
        };
}
# @return PrivateLinkResponse
#
sub private_collection_private_link_create {
    my ($self, %args) = @_;

    # verify the required parameter 'collection_id' is set
    unless (exists $args{'collection_id'}) {
      croak("Missing the required parameter 'collection_id' when calling private_collection_private_link_create");
    }

    # parse inputs
    my $_resource_path = '/account/collections/{collection_id}/private_links';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'collection_id'}) {
        my $_base_variable = "{" . "collection_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'collection_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'private_link'}) {
        $_body_data = $args{'private_link'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('PrivateLinkResponse', $response);
    return $_response_object;
}

#
# private_collection_private_link_delete
#
# Disable private link
# 
# @param int $collection_id Collection unique identifier (required)
# @param string $link_id Private link token (required)
{
    my $params = {
    'collection_id' => {
        data_type => 'int',
        description => 'Collection unique identifier',
        required => '1',
    },
    'link_id' => {
        data_type => 'string',
        description => 'Private link token',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_collection_private_link_delete' } = { 
    	summary => 'Disable private link',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_collection_private_link_delete {
    my ($self, %args) = @_;

    # verify the required parameter 'collection_id' is set
    unless (exists $args{'collection_id'}) {
      croak("Missing the required parameter 'collection_id' when calling private_collection_private_link_delete");
    }

    # verify the required parameter 'link_id' is set
    unless (exists $args{'link_id'}) {
      croak("Missing the required parameter 'link_id' when calling private_collection_private_link_delete");
    }

    # parse inputs
    my $_resource_path = '/account/collections/{collection_id}/private_links/{link_id}';

    my $_method = 'DELETE';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'collection_id'}) {
        my $_base_variable = "{" . "collection_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'collection_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'link_id'}) {
        my $_base_variable = "{" . "link_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'link_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_collection_private_link_update
#
# Update collection private link
# 
# @param int $collection_id Collection unique identifier (required)
# @param string $link_id Private link token (required)
# @param CollectionPrivateLinkCreator $private_link  (optional)
{
    my $params = {
    'collection_id' => {
        data_type => 'int',
        description => 'Collection unique identifier',
        required => '1',
    },
    'link_id' => {
        data_type => 'string',
        description => 'Private link token',
        required => '1',
    },
    'private_link' => {
        data_type => 'CollectionPrivateLinkCreator',
        description => '',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_collection_private_link_update' } = { 
    	summary => 'Update collection private link',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_collection_private_link_update {
    my ($self, %args) = @_;

    # verify the required parameter 'collection_id' is set
    unless (exists $args{'collection_id'}) {
      croak("Missing the required parameter 'collection_id' when calling private_collection_private_link_update");
    }

    # verify the required parameter 'link_id' is set
    unless (exists $args{'link_id'}) {
      croak("Missing the required parameter 'link_id' when calling private_collection_private_link_update");
    }

    # parse inputs
    my $_resource_path = '/account/collections/{collection_id}/private_links/{link_id}';

    my $_method = 'PUT';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'collection_id'}) {
        my $_base_variable = "{" . "collection_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'collection_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'link_id'}) {
        my $_base_variable = "{" . "link_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'link_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'private_link'}) {
        $_body_data = $args{'private_link'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_collection_private_links_list
#
# List collection private links
# 
# @param int $collection_id Collection unique identifier (required)
{
    my $params = {
    'collection_id' => {
        data_type => 'int',
        description => 'Collection unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_collection_private_links_list' } = { 
    	summary => 'List collection private links',
        params => $params,
        returns => 'ARRAY[PrivateLink]',
        };
}
# @return ARRAY[PrivateLink]
#
sub private_collection_private_links_list {
    my ($self, %args) = @_;

    # verify the required parameter 'collection_id' is set
    unless (exists $args{'collection_id'}) {
      croak("Missing the required parameter 'collection_id' when calling private_collection_private_links_list");
    }

    # parse inputs
    my $_resource_path = '/account/collections/{collection_id}/private_links';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'collection_id'}) {
        my $_base_variable = "{" . "collection_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'collection_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[PrivateLink]', $response);
    return $_response_object;
}

#
# private_collection_publish
#
# Private Collection Publish
# 
# @param int $collection_id Collection Unique identifier (required)
{
    my $params = {
    'collection_id' => {
        data_type => 'int',
        description => 'Collection Unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_collection_publish' } = { 
    	summary => 'Private Collection Publish',
        params => $params,
        returns => 'Location',
        };
}
# @return Location
#
sub private_collection_publish {
    my ($self, %args) = @_;

    # verify the required parameter 'collection_id' is set
    unless (exists $args{'collection_id'}) {
      croak("Missing the required parameter 'collection_id' when calling private_collection_publish");
    }

    # parse inputs
    my $_resource_path = '/account/collections/{collection_id}/publish';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'collection_id'}) {
        my $_base_variable = "{" . "collection_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'collection_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('Location', $response);
    return $_response_object;
}

#
# private_collection_reserve_doi
#
# Private Collection Reserve DOI
# 
# @param int $collection_id Collection Unique identifier (required)
{
    my $params = {
    'collection_id' => {
        data_type => 'int',
        description => 'Collection Unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_collection_reserve_doi' } = { 
    	summary => 'Private Collection Reserve DOI',
        params => $params,
        returns => 'CollectionDOI',
        };
}
# @return CollectionDOI
#
sub private_collection_reserve_doi {
    my ($self, %args) = @_;

    # verify the required parameter 'collection_id' is set
    unless (exists $args{'collection_id'}) {
      croak("Missing the required parameter 'collection_id' when calling private_collection_reserve_doi");
    }

    # parse inputs
    my $_resource_path = '/account/collections/{collection_id}/reserve_doi';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'collection_id'}) {
        my $_base_variable = "{" . "collection_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'collection_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('CollectionDOI', $response);
    return $_response_object;
}

#
# private_collection_reserve_handle
#
# Private Collection Reserve Handle
# 
# @param int $collection_id Collection Unique identifier (required)
{
    my $params = {
    'collection_id' => {
        data_type => 'int',
        description => 'Collection Unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_collection_reserve_handle' } = { 
    	summary => 'Private Collection Reserve Handle',
        params => $params,
        returns => 'CollectionHandle',
        };
}
# @return CollectionHandle
#
sub private_collection_reserve_handle {
    my ($self, %args) = @_;

    # verify the required parameter 'collection_id' is set
    unless (exists $args{'collection_id'}) {
      croak("Missing the required parameter 'collection_id' when calling private_collection_reserve_handle");
    }

    # parse inputs
    my $_resource_path = '/account/collections/{collection_id}/reserve_handle';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'collection_id'}) {
        my $_base_variable = "{" . "collection_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'collection_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('CollectionHandle', $response);
    return $_response_object;
}

#
# private_collection_resource
#
# Private Collection Resource
# 
# @param int $collection_id Collection unique identifier (required)
# @param Resource $resource Resource data (required)
{
    my $params = {
    'collection_id' => {
        data_type => 'int',
        description => 'Collection unique identifier',
        required => '1',
    },
    'resource' => {
        data_type => 'Resource',
        description => 'Resource data',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_collection_resource' } = { 
    	summary => 'Private Collection Resource',
        params => $params,
        returns => 'Location',
        };
}
# @return Location
#
sub private_collection_resource {
    my ($self, %args) = @_;

    # verify the required parameter 'collection_id' is set
    unless (exists $args{'collection_id'}) {
      croak("Missing the required parameter 'collection_id' when calling private_collection_resource");
    }

    # verify the required parameter 'resource' is set
    unless (exists $args{'resource'}) {
      croak("Missing the required parameter 'resource' when calling private_collection_resource");
    }

    # parse inputs
    my $_resource_path = '/account/collections/{collection_id}/resource';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'collection_id'}) {
        my $_base_variable = "{" . "collection_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'collection_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'resource'}) {
        $_body_data = $args{'resource'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('Location', $response);
    return $_response_object;
}

#
# private_collection_update
#
# Update collection
# 
# @param int $collection_id Collection Unique identifier (required)
# @param CollectionUpdate $collection Collection description (required)
{
    my $params = {
    'collection_id' => {
        data_type => 'int',
        description => 'Collection Unique identifier',
        required => '1',
    },
    'collection' => {
        data_type => 'CollectionUpdate',
        description => 'Collection description',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_collection_update' } = { 
    	summary => 'Update collection',
        params => $params,
        returns => 'LocationWarningsUpdate',
        };
}
# @return LocationWarningsUpdate
#
sub private_collection_update {
    my ($self, %args) = @_;

    # verify the required parameter 'collection_id' is set
    unless (exists $args{'collection_id'}) {
      croak("Missing the required parameter 'collection_id' when calling private_collection_update");
    }

    # verify the required parameter 'collection' is set
    unless (exists $args{'collection'}) {
      croak("Missing the required parameter 'collection' when calling private_collection_update");
    }

    # parse inputs
    my $_resource_path = '/account/collections/{collection_id}';

    my $_method = 'PUT';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'collection_id'}) {
        my $_base_variable = "{" . "collection_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'collection_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'collection'}) {
        $_body_data = $args{'collection'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('LocationWarningsUpdate', $response);
    return $_response_object;
}

#
# private_collections_list
#
# Private Collections List
# 
# @param int $page Page number. Used for pagination with page_size (optional)
# @param int $page_size The number of results included on a page. Used for pagination with page (optional, default to 10)
# @param int $limit Number of results included on a page. Used for pagination with query (optional)
# @param int $offset Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
# @param string $order The field by which to order. Default varies by endpoint/resource. (optional, default to published_date)
# @param string $order_direction  (optional, default to desc)
{
    my $params = {
    'page' => {
        data_type => 'int',
        description => 'Page number. Used for pagination with page_size',
        required => '0',
    },
    'page_size' => {
        data_type => 'int',
        description => 'The number of results included on a page. Used for pagination with page',
        required => '0',
    },
    'limit' => {
        data_type => 'int',
        description => 'Number of results included on a page. Used for pagination with query',
        required => '0',
    },
    'offset' => {
        data_type => 'int',
        description => 'Where to start the listing(the offset of the first result). Used for pagination with limit',
        required => '0',
    },
    'order' => {
        data_type => 'string',
        description => 'The field by which to order. Default varies by endpoint/resource.',
        required => '0',
    },
    'order_direction' => {
        data_type => 'string',
        description => '',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_collections_list' } = { 
    	summary => 'Private Collections List',
        params => $params,
        returns => 'ARRAY[Collection]',
        };
}
# @return ARRAY[Collection]
#
sub private_collections_list {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/account/collections';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # query params
    if ( exists $args{'page'}) {
        $query_params->{'page'} = $self->{api_client}->to_query_value($args{'page'});
    }

    # query params
    if ( exists $args{'page_size'}) {
        $query_params->{'page_size'} = $self->{api_client}->to_query_value($args{'page_size'});
    }

    # query params
    if ( exists $args{'limit'}) {
        $query_params->{'limit'} = $self->{api_client}->to_query_value($args{'limit'});
    }

    # query params
    if ( exists $args{'offset'}) {
        $query_params->{'offset'} = $self->{api_client}->to_query_value($args{'offset'});
    }

    # query params
    if ( exists $args{'order'}) {
        $query_params->{'order'} = $self->{api_client}->to_query_value($args{'order'});
    }

    # query params
    if ( exists $args{'order_direction'}) {
        $query_params->{'order_direction'} = $self->{api_client}->to_query_value($args{'order_direction'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Collection]', $response);
    return $_response_object;
}

#
# private_collections_search
#
# Private Collections Search
# 
# @param PrivateCollectionSearch $search Search Parameters (required)
{
    my $params = {
    'search' => {
        data_type => 'PrivateCollectionSearch',
        description => 'Search Parameters',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_collections_search' } = { 
    	summary => 'Private Collections Search',
        params => $params,
        returns => 'ARRAY[Collection]',
        };
}
# @return ARRAY[Collection]
#
sub private_collections_search {
    my ($self, %args) = @_;

    # verify the required parameter 'search' is set
    unless (exists $args{'search'}) {
      croak("Missing the required parameter 'search' when calling private_collections_search");
    }

    # parse inputs
    my $_resource_path = '/account/collections/search';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    my $_body_data;
    # body params
    if ( exists $args{'search'}) {
        $_body_data = $args{'search'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Collection]', $response);
    return $_response_object;
}

1;
