=begin comment

Figshare API

Figshare apiv2. Using Swagger 2.0

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git

=end comment

=cut

#
# NOTE: This class is auto generated by the swagger code generator program. 
# Do not edit the class manually.
# Ref: https://github.com/swagger-api/swagger-codegen
#
package WWW::SwaggerClient::InstitutionsApi;

require 5.6.0;
use strict;
use warnings;
use utf8; 
use Exporter;
use Carp qw( croak );
use Log::Any qw($log);

use WWW::SwaggerClient::ApiClient;

use base "Class::Data::Inheritable";

__PACKAGE__->mk_classdata('method_documentation' => {});

sub new {
    my $class = shift;
    my $api_client;

    if ($_[0] && ref $_[0] && ref $_[0] eq 'WWW::SwaggerClient::ApiClient' ) {
        $api_client = $_[0];
    } else {
        $api_client = WWW::SwaggerClient::ApiClient->new(@_);
    }

    bless { api_client => $api_client }, $class;

}


#
# account_institution_curation
#
# Institution Curation Review
# 
# @param int $curation_id ID of the curation (required)
{
    my $params = {
    'curation_id' => {
        data_type => 'int',
        description => 'ID of the curation',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'account_institution_curation' } = { 
    	summary => 'Institution Curation Review',
        params => $params,
        returns => 'CurationDetail',
        };
}
# @return CurationDetail
#
sub account_institution_curation {
    my ($self, %args) = @_;

    # verify the required parameter 'curation_id' is set
    unless (exists $args{'curation_id'}) {
      croak("Missing the required parameter 'curation_id' when calling account_institution_curation");
    }

    # parse inputs
    my $_resource_path = '/account/institution/review/{curation_id}';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'curation_id'}) {
        my $_base_variable = "{" . "curation_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'curation_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('CurationDetail', $response);
    return $_response_object;
}

#
# account_institution_curation_comments
#
# Institution Curation Review Comments
# 
# @param int $curation_id ID of the curation (required)
# @param int $limit Number of results included on a page. Used for pagination with query (optional)
# @param int $offset Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
{
    my $params = {
    'curation_id' => {
        data_type => 'int',
        description => 'ID of the curation',
        required => '1',
    },
    'limit' => {
        data_type => 'int',
        description => 'Number of results included on a page. Used for pagination with query',
        required => '0',
    },
    'offset' => {
        data_type => 'int',
        description => 'Where to start the listing(the offset of the first result). Used for pagination with limit',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'account_institution_curation_comments' } = { 
    	summary => 'Institution Curation Review Comments',
        params => $params,
        returns => 'CurationComment',
        };
}
# @return CurationComment
#
sub account_institution_curation_comments {
    my ($self, %args) = @_;

    # verify the required parameter 'curation_id' is set
    unless (exists $args{'curation_id'}) {
      croak("Missing the required parameter 'curation_id' when calling account_institution_curation_comments");
    }

    # parse inputs
    my $_resource_path = '/account/institution/review/{curation_id}/comments';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # query params
    if ( exists $args{'limit'}) {
        $query_params->{'limit'} = $self->{api_client}->to_query_value($args{'limit'});
    }

    # query params
    if ( exists $args{'offset'}) {
        $query_params->{'offset'} = $self->{api_client}->to_query_value($args{'offset'});
    }

    # path params
    if ( exists $args{'curation_id'}) {
        my $_base_variable = "{" . "curation_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'curation_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('CurationComment', $response);
    return $_response_object;
}

#
# account_institution_curation_comments_0
#
# POST Institution Curation Review Comment
# 
# @param int $curation_id ID of the curation (required)
# @param CurationCommentCreate $curation_comment The content/value of the comment. (required)
{
    my $params = {
    'curation_id' => {
        data_type => 'int',
        description => 'ID of the curation',
        required => '1',
    },
    'curation_comment' => {
        data_type => 'CurationCommentCreate',
        description => 'The content/value of the comment.',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'account_institution_curation_comments_0' } = { 
    	summary => 'POST Institution Curation Review Comment',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub account_institution_curation_comments_0 {
    my ($self, %args) = @_;

    # verify the required parameter 'curation_id' is set
    unless (exists $args{'curation_id'}) {
      croak("Missing the required parameter 'curation_id' when calling account_institution_curation_comments_0");
    }

    # verify the required parameter 'curation_comment' is set
    unless (exists $args{'curation_comment'}) {
      croak("Missing the required parameter 'curation_comment' when calling account_institution_curation_comments_0");
    }

    # parse inputs
    my $_resource_path = '/account/institution/review/{curation_id}/comments';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'curation_id'}) {
        my $_base_variable = "{" . "curation_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'curation_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'curation_comment'}) {
        $_body_data = $args{'curation_comment'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# account_institution_curations
#
# Institution Curation Reviews
# 
# @param int $group_id Filter by the group ID (optional)
# @param int $article_id Retrieve the reviews for this article (optional)
# @param string $status Filter by the status of the review (optional)
# @param int $limit Number of results included on a page. Used for pagination with query (optional)
# @param int $offset Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
{
    my $params = {
    'group_id' => {
        data_type => 'int',
        description => 'Filter by the group ID',
        required => '0',
    },
    'article_id' => {
        data_type => 'int',
        description => 'Retrieve the reviews for this article',
        required => '0',
    },
    'status' => {
        data_type => 'string',
        description => 'Filter by the status of the review',
        required => '0',
    },
    'limit' => {
        data_type => 'int',
        description => 'Number of results included on a page. Used for pagination with query',
        required => '0',
    },
    'offset' => {
        data_type => 'int',
        description => 'Where to start the listing(the offset of the first result). Used for pagination with limit',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'account_institution_curations' } = { 
    	summary => 'Institution Curation Reviews',
        params => $params,
        returns => 'Curation',
        };
}
# @return Curation
#
sub account_institution_curations {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/account/institution/reviews';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # query params
    if ( exists $args{'group_id'}) {
        $query_params->{'group_id'} = $self->{api_client}->to_query_value($args{'group_id'});
    }

    # query params
    if ( exists $args{'article_id'}) {
        $query_params->{'article_id'} = $self->{api_client}->to_query_value($args{'article_id'});
    }

    # query params
    if ( exists $args{'status'}) {
        $query_params->{'status'} = $self->{api_client}->to_query_value($args{'status'});
    }

    # query params
    if ( exists $args{'limit'}) {
        $query_params->{'limit'} = $self->{api_client}->to_query_value($args{'limit'});
    }

    # query params
    if ( exists $args{'offset'}) {
        $query_params->{'offset'} = $self->{api_client}->to_query_value($args{'offset'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('Curation', $response);
    return $_response_object;
}

#
# custom_fields_list
#
# Private account institution group custom fields
# 
# @param int $group_id Group_id (optional)
{
    my $params = {
    'group_id' => {
        data_type => 'int',
        description => 'Group_id',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'custom_fields_list' } = { 
    	summary => 'Private account institution group custom fields',
        params => $params,
        returns => 'ARRAY[ShortCustomField]',
        };
}
# @return ARRAY[ShortCustomField]
#
sub custom_fields_list {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/account/institution/custom_fields';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # query params
    if ( exists $args{'group_id'}) {
        $query_params->{'group_id'} = $self->{api_client}->to_query_value($args{'group_id'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[ShortCustomField]', $response);
    return $_response_object;
}

#
# custom_fields_upload
#
# Custom fields values files upload
# 
# @param int $custom_field_id Custom field identifier (required)
# @param File $external_file CSV file to be uploaded (optional)
{
    my $params = {
    'custom_field_id' => {
        data_type => 'int',
        description => 'Custom field identifier',
        required => '1',
    },
    'external_file' => {
        data_type => 'File',
        description => 'CSV file to be uploaded',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'custom_fields_upload' } = { 
    	summary => 'Custom fields values files upload',
        params => $params,
        returns => 'object',
        };
}
# @return object
#
sub custom_fields_upload {
    my ($self, %args) = @_;

    # verify the required parameter 'custom_field_id' is set
    unless (exists $args{'custom_field_id'}) {
      croak("Missing the required parameter 'custom_field_id' when calling custom_fields_upload");
    }

    # parse inputs
    my $_resource_path = '/account/institution/custom_fields/{custom_field_id}/items/upload';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('multipart/form-data');

    # path params
    if ( exists $args{'custom_field_id'}) {
        my $_base_variable = "{" . "custom_field_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'custom_field_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # form params
    if ( exists $args{'external_file'} ) {
        $form_params->{'external_file'} = [] unless defined $form_params->{'external_file'};
        push @{$form_params->{'external_file'}}, $args{'external_file'};
            }
    
    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('object', $response);
    return $_response_object;
}

#
# institution_articles
#
# Public Institution Articles
# 
# @param string $institution_string_id  (required)
# @param string $resource_id  (required)
# @param string $filename  (required)
{
    my $params = {
    'institution_string_id' => {
        data_type => 'string',
        description => '',
        required => '1',
    },
    'resource_id' => {
        data_type => 'string',
        description => '',
        required => '1',
    },
    'filename' => {
        data_type => 'string',
        description => '',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'institution_articles' } = { 
    	summary => 'Public Institution Articles',
        params => $params,
        returns => 'ARRAY[Article]',
        };
}
# @return ARRAY[Article]
#
sub institution_articles {
    my ($self, %args) = @_;

    # verify the required parameter 'institution_string_id' is set
    unless (exists $args{'institution_string_id'}) {
      croak("Missing the required parameter 'institution_string_id' when calling institution_articles");
    }

    # verify the required parameter 'resource_id' is set
    unless (exists $args{'resource_id'}) {
      croak("Missing the required parameter 'resource_id' when calling institution_articles");
    }

    # verify the required parameter 'filename' is set
    unless (exists $args{'filename'}) {
      croak("Missing the required parameter 'filename' when calling institution_articles");
    }

    # parse inputs
    my $_resource_path = '/institutions/{institution_string_id}/articles/filter-by';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # query params
    if ( exists $args{'resource_id'}) {
        $query_params->{'resource_id'} = $self->{api_client}->to_query_value($args{'resource_id'});
    }

    # query params
    if ( exists $args{'filename'}) {
        $query_params->{'filename'} = $self->{api_client}->to_query_value($args{'filename'});
    }

    # path params
    if ( exists $args{'institution_string_id'}) {
        my $_base_variable = "{" . "institution_string_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'institution_string_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Article]', $response);
    return $_response_object;
}

#
# institution_hrfeed_upload
#
# Private Institution HRfeed Upload
# 
# @param File $hrfeed You can find an example in the Hr Feed section (optional)
{
    my $params = {
    'hrfeed' => {
        data_type => 'File',
        description => 'You can find an example in the Hr Feed section',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'institution_hrfeed_upload' } = { 
    	summary => 'Private Institution HRfeed Upload',
        params => $params,
        returns => 'ResponseMessage',
        };
}
# @return ResponseMessage
#
sub institution_hrfeed_upload {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/institution/hrfeed/upload';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type('multipart/form-data');

    # form params
    if ( exists $args{'hrfeed'} ) {
        $form_params->{'hrfeed'} = [] unless defined $form_params->{'hrfeed'};
        push @{$form_params->{'hrfeed'}}, $args{'hrfeed'};
            }
    
    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ResponseMessage', $response);
    return $_response_object;
}

#
# private_account_institution_user
#
# Private Account Institution User
# 
# @param int $account_id Account identifier the user is associated to (required)
{
    my $params = {
    'account_id' => {
        data_type => 'int',
        description => 'Account identifier the user is associated to',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_account_institution_user' } = { 
    	summary => 'Private Account Institution User',
        params => $params,
        returns => 'User',
        };
}
# @return User
#
sub private_account_institution_user {
    my ($self, %args) = @_;

    # verify the required parameter 'account_id' is set
    unless (exists $args{'account_id'}) {
      croak("Missing the required parameter 'account_id' when calling private_account_institution_user");
    }

    # parse inputs
    my $_resource_path = '/account/institution/users/{account_id}';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'account_id'}) {
        my $_base_variable = "{" . "account_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'account_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('User', $response);
    return $_response_object;
}

#
# private_categories_list
#
# Private Account Categories
# 
{
    my $params = {
    };
    __PACKAGE__->method_documentation->{ 'private_categories_list' } = { 
    	summary => 'Private Account Categories',
        params => $params,
        returns => 'ARRAY[Category]',
        };
}
# @return ARRAY[Category]
#
sub private_categories_list {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/account/categories';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Category]', $response);
    return $_response_object;
}

#
# private_group_embargo_options_details
#
# Private Account Institution Group Embargo Options
# 
# @param int $group_id Group identifier (required)
{
    my $params = {
    'group_id' => {
        data_type => 'int',
        description => 'Group identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_group_embargo_options_details' } = { 
    	summary => 'Private Account Institution Group Embargo Options',
        params => $params,
        returns => 'ARRAY[GroupEmbargoOptions]',
        };
}
# @return ARRAY[GroupEmbargoOptions]
#
sub private_group_embargo_options_details {
    my ($self, %args) = @_;

    # verify the required parameter 'group_id' is set
    unless (exists $args{'group_id'}) {
      croak("Missing the required parameter 'group_id' when calling private_group_embargo_options_details");
    }

    # parse inputs
    my $_resource_path = '/account/institution/groups/{group_id}/embargo_options';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'group_id'}) {
        my $_base_variable = "{" . "group_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'group_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[GroupEmbargoOptions]', $response);
    return $_response_object;
}

#
# private_institution_account_group_role_delete
#
# Delete Institution Account Group Role
# 
# @param int $account_id Account identifier for which to remove the role (required)
# @param int $group_id Group identifier for which to remove the role (required)
# @param int $role_id Role identifier (required)
{
    my $params = {
    'account_id' => {
        data_type => 'int',
        description => 'Account identifier for which to remove the role',
        required => '1',
    },
    'group_id' => {
        data_type => 'int',
        description => 'Group identifier for which to remove the role',
        required => '1',
    },
    'role_id' => {
        data_type => 'int',
        description => 'Role identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_institution_account_group_role_delete' } = { 
    	summary => 'Delete Institution Account Group Role',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_institution_account_group_role_delete {
    my ($self, %args) = @_;

    # verify the required parameter 'account_id' is set
    unless (exists $args{'account_id'}) {
      croak("Missing the required parameter 'account_id' when calling private_institution_account_group_role_delete");
    }

    # verify the required parameter 'group_id' is set
    unless (exists $args{'group_id'}) {
      croak("Missing the required parameter 'group_id' when calling private_institution_account_group_role_delete");
    }

    # verify the required parameter 'role_id' is set
    unless (exists $args{'role_id'}) {
      croak("Missing the required parameter 'role_id' when calling private_institution_account_group_role_delete");
    }

    # parse inputs
    my $_resource_path = '/account/institution/roles/{account_id}/{group_id}/{role_id}';

    my $_method = 'DELETE';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'account_id'}) {
        my $_base_variable = "{" . "account_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'account_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'group_id'}) {
        my $_base_variable = "{" . "group_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'group_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'role_id'}) {
        my $_base_variable = "{" . "role_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'role_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_institution_account_group_roles
#
# List Institution Account Group Roles
# 
# @param int $account_id Account identifier the user is associated to (required)
{
    my $params = {
    'account_id' => {
        data_type => 'int',
        description => 'Account identifier the user is associated to',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_institution_account_group_roles' } = { 
    	summary => 'List Institution Account Group Roles',
        params => $params,
        returns => 'AccountGroupRoles',
        };
}
# @return AccountGroupRoles
#
sub private_institution_account_group_roles {
    my ($self, %args) = @_;

    # verify the required parameter 'account_id' is set
    unless (exists $args{'account_id'}) {
      croak("Missing the required parameter 'account_id' when calling private_institution_account_group_roles");
    }

    # parse inputs
    my $_resource_path = '/account/institution/roles/{account_id}';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'account_id'}) {
        my $_base_variable = "{" . "account_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'account_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('AccountGroupRoles', $response);
    return $_response_object;
}

#
# private_institution_account_group_roles_create
#
# Add Institution Account Group Roles
# 
# @param int $account_id Account identifier the user is associated to (required)
# @param AccountGroupRolesCreate $account Account description (required)
{
    my $params = {
    'account_id' => {
        data_type => 'int',
        description => 'Account identifier the user is associated to',
        required => '1',
    },
    'account' => {
        data_type => 'AccountGroupRolesCreate',
        description => 'Account description',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_institution_account_group_roles_create' } = { 
    	summary => 'Add Institution Account Group Roles',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_institution_account_group_roles_create {
    my ($self, %args) = @_;

    # verify the required parameter 'account_id' is set
    unless (exists $args{'account_id'}) {
      croak("Missing the required parameter 'account_id' when calling private_institution_account_group_roles_create");
    }

    # verify the required parameter 'account' is set
    unless (exists $args{'account'}) {
      croak("Missing the required parameter 'account' when calling private_institution_account_group_roles_create");
    }

    # parse inputs
    my $_resource_path = '/account/institution/roles/{account_id}';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'account_id'}) {
        my $_base_variable = "{" . "account_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'account_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'account'}) {
        $_body_data = $args{'account'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_institution_accounts_create
#
# Create new Institution Account
# 
# @param AccountCreate $account Account description (required)
{
    my $params = {
    'account' => {
        data_type => 'AccountCreate',
        description => 'Account description',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_institution_accounts_create' } = { 
    	summary => 'Create new Institution Account',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_institution_accounts_create {
    my ($self, %args) = @_;

    # verify the required parameter 'account' is set
    unless (exists $args{'account'}) {
      croak("Missing the required parameter 'account' when calling private_institution_accounts_create");
    }

    # parse inputs
    my $_resource_path = '/account/institution/accounts';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    my $_body_data;
    # body params
    if ( exists $args{'account'}) {
        $_body_data = $args{'account'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_institution_accounts_list
#
# Private Account Institution Accounts
# 
# @param int $page Page number. Used for pagination with page_size (optional)
# @param int $page_size The number of results included on a page. Used for pagination with page (optional, default to 10)
# @param int $limit Number of results included on a page. Used for pagination with query (optional)
# @param int $offset Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
# @param int $is_active Filter by active status (optional)
# @param string $institution_user_id Filter by institution_user_id (optional)
# @param string $email Filter by email (optional)
# @param int $id_lte Retrieve accounts with an ID lower or equal to the specified value (optional)
# @param int $id_gte Retrieve accounts with an ID greater or equal to the specified value (optional)
{
    my $params = {
    'page' => {
        data_type => 'int',
        description => 'Page number. Used for pagination with page_size',
        required => '0',
    },
    'page_size' => {
        data_type => 'int',
        description => 'The number of results included on a page. Used for pagination with page',
        required => '0',
    },
    'limit' => {
        data_type => 'int',
        description => 'Number of results included on a page. Used for pagination with query',
        required => '0',
    },
    'offset' => {
        data_type => 'int',
        description => 'Where to start the listing(the offset of the first result). Used for pagination with limit',
        required => '0',
    },
    'is_active' => {
        data_type => 'int',
        description => 'Filter by active status',
        required => '0',
    },
    'institution_user_id' => {
        data_type => 'string',
        description => 'Filter by institution_user_id',
        required => '0',
    },
    'email' => {
        data_type => 'string',
        description => 'Filter by email',
        required => '0',
    },
    'id_lte' => {
        data_type => 'int',
        description => 'Retrieve accounts with an ID lower or equal to the specified value',
        required => '0',
    },
    'id_gte' => {
        data_type => 'int',
        description => 'Retrieve accounts with an ID greater or equal to the specified value',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_institution_accounts_list' } = { 
    	summary => 'Private Account Institution Accounts',
        params => $params,
        returns => 'ARRAY[ShortAccount]',
        };
}
# @return ARRAY[ShortAccount]
#
sub private_institution_accounts_list {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/account/institution/accounts';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # query params
    if ( exists $args{'page'}) {
        $query_params->{'page'} = $self->{api_client}->to_query_value($args{'page'});
    }

    # query params
    if ( exists $args{'page_size'}) {
        $query_params->{'page_size'} = $self->{api_client}->to_query_value($args{'page_size'});
    }

    # query params
    if ( exists $args{'limit'}) {
        $query_params->{'limit'} = $self->{api_client}->to_query_value($args{'limit'});
    }

    # query params
    if ( exists $args{'offset'}) {
        $query_params->{'offset'} = $self->{api_client}->to_query_value($args{'offset'});
    }

    # query params
    if ( exists $args{'is_active'}) {
        $query_params->{'is_active'} = $self->{api_client}->to_query_value($args{'is_active'});
    }

    # query params
    if ( exists $args{'institution_user_id'}) {
        $query_params->{'institution_user_id'} = $self->{api_client}->to_query_value($args{'institution_user_id'});
    }

    # query params
    if ( exists $args{'email'}) {
        $query_params->{'email'} = $self->{api_client}->to_query_value($args{'email'});
    }

    # query params
    if ( exists $args{'id_lte'}) {
        $query_params->{'id_lte'} = $self->{api_client}->to_query_value($args{'id_lte'});
    }

    # query params
    if ( exists $args{'id_gte'}) {
        $query_params->{'id_gte'} = $self->{api_client}->to_query_value($args{'id_gte'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[ShortAccount]', $response);
    return $_response_object;
}

#
# private_institution_accounts_search
#
# Private Account Institution Accounts Search
# 
# @param InstitutionAccountsSearch $search Search Parameters (required)
{
    my $params = {
    'search' => {
        data_type => 'InstitutionAccountsSearch',
        description => 'Search Parameters',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_institution_accounts_search' } = { 
    	summary => 'Private Account Institution Accounts Search',
        params => $params,
        returns => 'ARRAY[ShortAccount]',
        };
}
# @return ARRAY[ShortAccount]
#
sub private_institution_accounts_search {
    my ($self, %args) = @_;

    # verify the required parameter 'search' is set
    unless (exists $args{'search'}) {
      croak("Missing the required parameter 'search' when calling private_institution_accounts_search");
    }

    # parse inputs
    my $_resource_path = '/account/institution/accounts/search';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    my $_body_data;
    # body params
    if ( exists $args{'search'}) {
        $_body_data = $args{'search'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[ShortAccount]', $response);
    return $_response_object;
}

#
# private_institution_accounts_update
#
# Update Institution Account
# 
# @param int $account_id Account identifier the user is associated to (required)
# @param AccountUpdate $account Account description (required)
{
    my $params = {
    'account_id' => {
        data_type => 'int',
        description => 'Account identifier the user is associated to',
        required => '1',
    },
    'account' => {
        data_type => 'AccountUpdate',
        description => 'Account description',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_institution_accounts_update' } = { 
    	summary => 'Update Institution Account',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_institution_accounts_update {
    my ($self, %args) = @_;

    # verify the required parameter 'account_id' is set
    unless (exists $args{'account_id'}) {
      croak("Missing the required parameter 'account_id' when calling private_institution_accounts_update");
    }

    # verify the required parameter 'account' is set
    unless (exists $args{'account'}) {
      croak("Missing the required parameter 'account' when calling private_institution_accounts_update");
    }

    # parse inputs
    my $_resource_path = '/account/institution/accounts/{account_id}';

    my $_method = 'PUT';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'account_id'}) {
        my $_base_variable = "{" . "account_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'account_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'account'}) {
        $_body_data = $args{'account'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_institution_articles
#
# Private Institution Articles
# 
# @param int $page Page number. Used for pagination with page_size (optional)
# @param int $page_size The number of results included on a page. Used for pagination with page (optional, default to 10)
# @param int $limit Number of results included on a page. Used for pagination with query (optional)
# @param int $offset Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
# @param string $order The field by which to order. Default varies by endpoint/resource. (optional, default to published_date)
# @param string $order_direction  (optional, default to desc)
# @param string $published_since Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)
# @param string $modified_since Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)
# @param int $status only return collections with this status (optional)
# @param string $resource_doi only return collections with this resource_doi (optional)
# @param int $item_type Only return articles with the respective type. Mapping for item_type is: 1 - Figure, 2 - Media, 3 - Dataset, 5 - Poster, 6 - Journal contribution, 7 - Presentation, 8 - Thesis, 9 - Software, 11 - Online resource, 12 - Preprint, 13 - Book, 14 - Conference contribution, 15 - Chapter, 16 - Peer review, 17 - Educational resource, 18 - Report, 19 - Standard, 20 - Composition, 21 - Funding, 22 - Physical object, 23 - Data management plan, 24 - Workflow, 25 - Monograph, 26 - Performance, 27 - Event, 28 - Service, 29 - Model (optional)
{
    my $params = {
    'page' => {
        data_type => 'int',
        description => 'Page number. Used for pagination with page_size',
        required => '0',
    },
    'page_size' => {
        data_type => 'int',
        description => 'The number of results included on a page. Used for pagination with page',
        required => '0',
    },
    'limit' => {
        data_type => 'int',
        description => 'Number of results included on a page. Used for pagination with query',
        required => '0',
    },
    'offset' => {
        data_type => 'int',
        description => 'Where to start the listing(the offset of the first result). Used for pagination with limit',
        required => '0',
    },
    'order' => {
        data_type => 'string',
        description => 'The field by which to order. Default varies by endpoint/resource.',
        required => '0',
    },
    'order_direction' => {
        data_type => 'string',
        description => '',
        required => '0',
    },
    'published_since' => {
        data_type => 'string',
        description => 'Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD',
        required => '0',
    },
    'modified_since' => {
        data_type => 'string',
        description => 'Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD',
        required => '0',
    },
    'status' => {
        data_type => 'int',
        description => 'only return collections with this status',
        required => '0',
    },
    'resource_doi' => {
        data_type => 'string',
        description => 'only return collections with this resource_doi',
        required => '0',
    },
    'item_type' => {
        data_type => 'int',
        description => 'Only return articles with the respective type. Mapping for item_type is: 1 - Figure, 2 - Media, 3 - Dataset, 5 - Poster, 6 - Journal contribution, 7 - Presentation, 8 - Thesis, 9 - Software, 11 - Online resource, 12 - Preprint, 13 - Book, 14 - Conference contribution, 15 - Chapter, 16 - Peer review, 17 - Educational resource, 18 - Report, 19 - Standard, 20 - Composition, 21 - Funding, 22 - Physical object, 23 - Data management plan, 24 - Workflow, 25 - Monograph, 26 - Performance, 27 - Event, 28 - Service, 29 - Model',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_institution_articles' } = { 
    	summary => 'Private Institution Articles',
        params => $params,
        returns => 'ARRAY[Article]',
        };
}
# @return ARRAY[Article]
#
sub private_institution_articles {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/account/institution/articles';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # query params
    if ( exists $args{'page'}) {
        $query_params->{'page'} = $self->{api_client}->to_query_value($args{'page'});
    }

    # query params
    if ( exists $args{'page_size'}) {
        $query_params->{'page_size'} = $self->{api_client}->to_query_value($args{'page_size'});
    }

    # query params
    if ( exists $args{'limit'}) {
        $query_params->{'limit'} = $self->{api_client}->to_query_value($args{'limit'});
    }

    # query params
    if ( exists $args{'offset'}) {
        $query_params->{'offset'} = $self->{api_client}->to_query_value($args{'offset'});
    }

    # query params
    if ( exists $args{'order'}) {
        $query_params->{'order'} = $self->{api_client}->to_query_value($args{'order'});
    }

    # query params
    if ( exists $args{'order_direction'}) {
        $query_params->{'order_direction'} = $self->{api_client}->to_query_value($args{'order_direction'});
    }

    # query params
    if ( exists $args{'published_since'}) {
        $query_params->{'published_since'} = $self->{api_client}->to_query_value($args{'published_since'});
    }

    # query params
    if ( exists $args{'modified_since'}) {
        $query_params->{'modified_since'} = $self->{api_client}->to_query_value($args{'modified_since'});
    }

    # query params
    if ( exists $args{'status'}) {
        $query_params->{'status'} = $self->{api_client}->to_query_value($args{'status'});
    }

    # query params
    if ( exists $args{'resource_doi'}) {
        $query_params->{'resource_doi'} = $self->{api_client}->to_query_value($args{'resource_doi'});
    }

    # query params
    if ( exists $args{'item_type'}) {
        $query_params->{'item_type'} = $self->{api_client}->to_query_value($args{'item_type'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Article]', $response);
    return $_response_object;
}

#
# private_institution_details
#
# Private Account Institutions
# 
{
    my $params = {
    };
    __PACKAGE__->method_documentation->{ 'private_institution_details' } = { 
    	summary => 'Private Account Institutions',
        params => $params,
        returns => 'Institution',
        };
}
# @return Institution
#
sub private_institution_details {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/account/institution';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('Institution', $response);
    return $_response_object;
}

#
# private_institution_embargo_options_details
#
# Private Account Institution embargo options
# 
{
    my $params = {
    };
    __PACKAGE__->method_documentation->{ 'private_institution_embargo_options_details' } = { 
    	summary => 'Private Account Institution embargo options',
        params => $params,
        returns => 'ARRAY[GroupEmbargoOptions]',
        };
}
# @return ARRAY[GroupEmbargoOptions]
#
sub private_institution_embargo_options_details {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/account/institution/embargo_options';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[GroupEmbargoOptions]', $response);
    return $_response_object;
}

#
# private_institution_groups_list
#
# Private Account Institution Groups
# 
{
    my $params = {
    };
    __PACKAGE__->method_documentation->{ 'private_institution_groups_list' } = { 
    	summary => 'Private Account Institution Groups',
        params => $params,
        returns => 'ARRAY[Group]',
        };
}
# @return ARRAY[Group]
#
sub private_institution_groups_list {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/account/institution/groups';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Group]', $response);
    return $_response_object;
}

#
# private_institution_roles_list
#
# Private Account Institution Roles
# 
{
    my $params = {
    };
    __PACKAGE__->method_documentation->{ 'private_institution_roles_list' } = { 
    	summary => 'Private Account Institution Roles',
        params => $params,
        returns => 'ARRAY[Role]',
        };
}
# @return ARRAY[Role]
#
sub private_institution_roles_list {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/account/institution/roles';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Role]', $response);
    return $_response_object;
}

1;
