=begin comment

Figshare API

Figshare apiv2. Using Swagger 2.0

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git

=end comment

=cut

#
# NOTE: This class is auto generated by the swagger code generator program. 
# Do not edit the class manually.
# Ref: https://github.com/swagger-api/swagger-codegen
#
package WWW::SwaggerClient::Object::ArticleUpdate;

require 5.6.0;
use strict;
use warnings;
use utf8;
use JSON qw(decode_json);
use Data::Dumper;
use Module::Runtime qw(use_module);
use Log::Any qw($log);
use Date::Parse;
use DateTime;

use WWW::SwaggerClient::Object::CustomArticleFieldAdd;
use WWW::SwaggerClient::Object::FundingCreate;
use WWW::SwaggerClient::Object::RelatedMaterial;
use WWW::SwaggerClient::Object::TimelineUpdate;

use base ("Class::Accessor", "Class::Data::Inheritable");


#
#
#
# NOTE: This class is auto generated by the swagger code generator program. Do not edit the class manually.
# REF: https://github.com/swagger-api/swagger-codegen
#

=begin comment

Figshare API

Figshare apiv2. Using Swagger 2.0

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git

=end comment

=cut

#
# NOTE: This class is auto generated by the swagger code generator program. 
# Do not edit the class manually.
# Ref: https://github.com/swagger-api/swagger-codegen
#
__PACKAGE__->mk_classdata('attribute_map' => {});
__PACKAGE__->mk_classdata('swagger_types' => {});
__PACKAGE__->mk_classdata('method_documentation' => {}); 
__PACKAGE__->mk_classdata('class_documentation' => {});

# new object
sub new { 
    my ($class, %args) = @_; 

	my $self = bless {}, $class;
	
	foreach my $attribute (keys %{$class->attribute_map}) {
		my $args_key = $class->attribute_map->{$attribute};
		$self->$attribute( $args{ $args_key } );
	}
	
	return $self;
}  

# return perl hash
sub to_hash {
    return decode_json(JSON->new->convert_blessed->encode( shift ));
}

# used by JSON for serialization
sub TO_JSON { 
    my $self = shift;
    my $_data = {};
    foreach my $_key (keys %{$self->attribute_map}) {
        if (defined $self->{$_key}) {
            $_data->{$self->attribute_map->{$_key}} = $self->{$_key};
        }
    }
    return $_data;
}

# from Perl hashref
sub from_hash {
    my ($self, $hash) = @_;

    # loop through attributes and use swagger_types to deserialize the data
    while ( my ($_key, $_type) = each %{$self->swagger_types} ) {
    	my $_json_attribute = $self->attribute_map->{$_key}; 
        if ($_type =~ /^array\[/i) { # array
            my $_subclass = substr($_type, 6, -1);
            my @_array = ();
            foreach my $_element (@{$hash->{$_json_attribute}}) {
                push @_array, $self->_deserialize($_subclass, $_element);
            }
            $self->{$_key} = \@_array;
        } elsif (exists $hash->{$_json_attribute}) { #hash(model), primitive, datetime
            $self->{$_key} = $self->_deserialize($_type, $hash->{$_json_attribute});
        } else {
        	$log->debugf("Warning: %s (%s) does not exist in input hash\n", $_key, $_json_attribute);
        }
    }
  
    return $self;
}

# deserialize non-array data
sub _deserialize {
    my ($self, $type, $data) = @_;
    $log->debugf("deserializing %s with %s",Dumper($data), $type);
        
    if ($type eq 'DateTime') {
        return DateTime->from_epoch(epoch => str2time($data));
    } elsif ( grep( /^$type$/, ('int', 'double', 'string', 'boolean'))) {
        return $data;
    } else { # hash(model)
        my $_instance = eval "WWW::SwaggerClient::Object::$type->new()";
        return $_instance->from_hash($data);
    }
}



__PACKAGE__->class_documentation({description => '',
                                  class => 'ArticleUpdate',
                                  required => [], # TODO
}                                 );

__PACKAGE__->method_documentation({
    'title' => {
    	datatype => 'string',
    	base_name => 'title',
    	description => 'Title of article',
    	format => '',
    	read_only => '',
    		},
    'description' => {
    	datatype => 'string',
    	base_name => 'description',
    	description => 'The article description. In a publisher case, usually this is the remote article description',
    	format => '',
    	read_only => '',
    		},
    'is_metadata_record' => {
    	datatype => 'boolean',
    	base_name => 'is_metadata_record',
    	description => 'True if article has no files',
    	format => '',
    	read_only => '',
    		},
    'metadata_reason' => {
    	datatype => 'string',
    	base_name => 'metadata_reason',
    	description => 'Article metadata reason',
    	format => '',
    	read_only => '',
    		},
    'tags' => {
    	datatype => 'ARRAY[string]',
    	base_name => 'tags',
    	description => 'List of tags to be associated with the article. Keywords can be used instead',
    	format => '',
    	read_only => '',
    		},
    'keywords' => {
    	datatype => 'ARRAY[string]',
    	base_name => 'keywords',
    	description => 'List of tags to be associated with the article. Tags can be used instead',
    	format => '',
    	read_only => '',
    		},
    'references' => {
    	datatype => 'ARRAY[string]',
    	base_name => 'references',
    	description => 'List of links to be associated with the article (e.g [\&quot;http://link1\&quot;, \&quot;http://link2\&quot;, \&quot;http://link3\&quot;])',
    	format => '',
    	read_only => '',
    		},
    'related_materials' => {
    	datatype => 'ARRAY[RelatedMaterial]',
    	base_name => 'related_materials',
    	description => 'List of related materials; supersedes references and resource DOI/title.',
    	format => '',
    	read_only => '',
    		},
    'categories' => {
    	datatype => 'ARRAY[int]',
    	base_name => 'categories',
    	description => 'List of category ids to be associated with the article(e.g [1, 23, 33, 66])',
    	format => '',
    	read_only => '',
    		},
    'categories_by_source_id' => {
    	datatype => 'ARRAY[string]',
    	base_name => 'categories_by_source_id',
    	description => 'List of category source ids to be associated with the article, supersedes the categories property',
    	format => '',
    	read_only => '',
    		},
    'authors' => {
    	datatype => 'ARRAY[object]',
    	base_name => 'authors',
    	description => 'List of authors to be associated with the article. The list can contain the following fields: id, name, first_name, last_name, email, orcid_id. If an id is supplied, it will take priority and everything else will be ignored. For adding more authors use the specific authors endpoint.',
    	format => '',
    	read_only => '',
    		},
    'custom_fields' => {
    	datatype => 'object',
    	base_name => 'custom_fields',
    	description => 'List of key, values pairs to be associated with the article',
    	format => '',
    	read_only => '',
    		},
    'custom_fields_list' => {
    	datatype => 'ARRAY[CustomArticleFieldAdd]',
    	base_name => 'custom_fields_list',
    	description => 'List of custom fields values, supersedes custom_fields parameter',
    	format => '',
    	read_only => '',
    		},
    'defined_type' => {
    	datatype => 'string',
    	base_name => 'defined_type',
    	description => '&lt;b&gt;One of:&lt;/b&gt; &lt;code&gt;figure&lt;/code&gt; &lt;code&gt;online resource&lt;/code&gt; &lt;code&gt;preprint&lt;/code&gt; &lt;code&gt;book&lt;/code&gt; &lt;code&gt;conference contribution&lt;/code&gt; &lt;code&gt;media&lt;/code&gt; &lt;code&gt;dataset&lt;/code&gt; &lt;code&gt;poster&lt;/code&gt; &lt;code&gt;journal contribution&lt;/code&gt; &lt;code&gt;presentation&lt;/code&gt; &lt;code&gt;thesis&lt;/code&gt; &lt;code&gt;software&lt;/code&gt;',
    	format => '',
    	read_only => '',
    		},
    'funding' => {
    	datatype => 'string',
    	base_name => 'funding',
    	description => 'Grant number or funding authority',
    	format => '',
    	read_only => '',
    		},
    'funding_list' => {
    	datatype => 'ARRAY[FundingCreate]',
    	base_name => 'funding_list',
    	description => 'Funding creation / update items',
    	format => '',
    	read_only => '',
    		},
    'license' => {
    	datatype => 'int',
    	base_name => 'license',
    	description => 'License id for this article.',
    	format => '',
    	read_only => '',
    		},
    'doi' => {
    	datatype => 'string',
    	base_name => 'doi',
    	description => 'Not applicable for regular users. In an institutional case, make sure your group supports setting DOIs. This setting is applied by figshare via opening a ticket through our support/helpdesk system.',
    	format => '',
    	read_only => '',
    		},
    'handle' => {
    	datatype => 'string',
    	base_name => 'handle',
    	description => 'Not applicable for regular users. In an institutional case, make sure your group supports setting Handles. This setting is applied by figshare via opening a ticket through our support/helpdesk system.',
    	format => '',
    	read_only => '',
    		},
    'resource_doi' => {
    	datatype => 'string',
    	base_name => 'resource_doi',
    	description => 'Deprecated by related materials. Not applicable to regular users. In a publisher case, this is the publisher article DOI.',
    	format => '',
    	read_only => '',
    		},
    'resource_title' => {
    	datatype => 'string',
    	base_name => 'resource_title',
    	description => 'Deprecated by related materials. Not applicable to regular users. In a publisher case, this is the publisher article title.',
    	format => '',
    	read_only => '',
    		},
    'timeline' => {
    	datatype => 'TimelineUpdate',
    	base_name => 'timeline',
    	description => 'Various timeline dates',
    	format => '',
    	read_only => '',
    		},
    'download_disabled' => {
    	datatype => 'boolean',
    	base_name => 'download_disabled',
    	description => 'If true, downloading of files for this article is disabled',
    	format => '',
    	read_only => '',
    		},
    'group_id' => {
    	datatype => 'int',
    	base_name => 'group_id',
    	description => 'Not applicable to regular users. This field is reserved to institutions/publishers with access to assign to specific groups',
    	format => '',
    	read_only => '',
    		},
});

__PACKAGE__->swagger_types( {
    'title' => 'string',
    'description' => 'string',
    'is_metadata_record' => 'boolean',
    'metadata_reason' => 'string',
    'tags' => 'ARRAY[string]',
    'keywords' => 'ARRAY[string]',
    'references' => 'ARRAY[string]',
    'related_materials' => 'ARRAY[RelatedMaterial]',
    'categories' => 'ARRAY[int]',
    'categories_by_source_id' => 'ARRAY[string]',
    'authors' => 'ARRAY[object]',
    'custom_fields' => 'object',
    'custom_fields_list' => 'ARRAY[CustomArticleFieldAdd]',
    'defined_type' => 'string',
    'funding' => 'string',
    'funding_list' => 'ARRAY[FundingCreate]',
    'license' => 'int',
    'doi' => 'string',
    'handle' => 'string',
    'resource_doi' => 'string',
    'resource_title' => 'string',
    'timeline' => 'TimelineUpdate',
    'download_disabled' => 'boolean',
    'group_id' => 'int'
} );

__PACKAGE__->attribute_map( {
    'title' => 'title',
    'description' => 'description',
    'is_metadata_record' => 'is_metadata_record',
    'metadata_reason' => 'metadata_reason',
    'tags' => 'tags',
    'keywords' => 'keywords',
    'references' => 'references',
    'related_materials' => 'related_materials',
    'categories' => 'categories',
    'categories_by_source_id' => 'categories_by_source_id',
    'authors' => 'authors',
    'custom_fields' => 'custom_fields',
    'custom_fields_list' => 'custom_fields_list',
    'defined_type' => 'defined_type',
    'funding' => 'funding',
    'funding_list' => 'funding_list',
    'license' => 'license',
    'doi' => 'doi',
    'handle' => 'handle',
    'resource_doi' => 'resource_doi',
    'resource_title' => 'resource_title',
    'timeline' => 'timeline',
    'download_disabled' => 'download_disabled',
    'group_id' => 'group_id'
} );

__PACKAGE__->mk_accessors(keys %{__PACKAGE__->attribute_map});


1;
