=begin comment

Figshare API

Figshare apiv2. Using Swagger 2.0

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git

=end comment

=cut

#
# NOTE: This class is auto generated by the swagger code generator program. 
# Do not edit the class manually.
# Ref: https://github.com/swagger-api/swagger-codegen
#
package WWW::SwaggerClient::Object::PrivateArticleSearch;

require 5.6.0;
use strict;
use warnings;
use utf8;
use JSON qw(decode_json);
use Data::Dumper;
use Module::Runtime qw(use_module);
use Log::Any qw($log);
use Date::Parse;
use DateTime;

use WWW::SwaggerClient::Object::ArticleSearch;

use base ("Class::Accessor", "Class::Data::Inheritable");


#
#
#
# NOTE: This class is auto generated by the swagger code generator program. Do not edit the class manually.
# REF: https://github.com/swagger-api/swagger-codegen
#

=begin comment

Figshare API

Figshare apiv2. Using Swagger 2.0

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git

=end comment

=cut

#
# NOTE: This class is auto generated by the swagger code generator program. 
# Do not edit the class manually.
# Ref: https://github.com/swagger-api/swagger-codegen
#
__PACKAGE__->mk_classdata('attribute_map' => {});
__PACKAGE__->mk_classdata('swagger_types' => {});
__PACKAGE__->mk_classdata('method_documentation' => {}); 
__PACKAGE__->mk_classdata('class_documentation' => {});

# new object
sub new { 
    my ($class, %args) = @_; 

	my $self = bless {}, $class;
	
	foreach my $attribute (keys %{$class->attribute_map}) {
		my $args_key = $class->attribute_map->{$attribute};
		$self->$attribute( $args{ $args_key } );
	}
	
	return $self;
}  

# return perl hash
sub to_hash {
    return decode_json(JSON->new->convert_blessed->encode( shift ));
}

# used by JSON for serialization
sub TO_JSON { 
    my $self = shift;
    my $_data = {};
    foreach my $_key (keys %{$self->attribute_map}) {
        if (defined $self->{$_key}) {
            $_data->{$self->attribute_map->{$_key}} = $self->{$_key};
        }
    }
    return $_data;
}

# from Perl hashref
sub from_hash {
    my ($self, $hash) = @_;

    # loop through attributes and use swagger_types to deserialize the data
    while ( my ($_key, $_type) = each %{$self->swagger_types} ) {
    	my $_json_attribute = $self->attribute_map->{$_key}; 
        if ($_type =~ /^array\[/i) { # array
            my $_subclass = substr($_type, 6, -1);
            my @_array = ();
            foreach my $_element (@{$hash->{$_json_attribute}}) {
                push @_array, $self->_deserialize($_subclass, $_element);
            }
            $self->{$_key} = \@_array;
        } elsif (exists $hash->{$_json_attribute}) { #hash(model), primitive, datetime
            $self->{$_key} = $self->_deserialize($_type, $hash->{$_json_attribute});
        } else {
        	$log->debugf("Warning: %s (%s) does not exist in input hash\n", $_key, $_json_attribute);
        }
    }
  
    return $self;
}

# deserialize non-array data
sub _deserialize {
    my ($self, $type, $data) = @_;
    $log->debugf("deserializing %s with %s",Dumper($data), $type);
        
    if ($type eq 'DateTime') {
        return DateTime->from_epoch(epoch => str2time($data));
    } elsif ( grep( /^$type$/, ('int', 'double', 'string', 'boolean'))) {
        return $data;
    } else { # hash(model)
        my $_instance = eval "WWW::SwaggerClient::Object::$type->new()";
        return $_instance->from_hash($data);
    }
}



__PACKAGE__->class_documentation({description => '',
                                  class => 'PrivateArticleSearch',
                                  required => [], # TODO
}                                 );

__PACKAGE__->method_documentation({
    'resource_doi' => {
    	datatype => 'string',
    	base_name => 'resource_doi',
    	description => 'Only return articles with this resource_doi',
    	format => '',
    	read_only => '',
    		},
    'item_type' => {
    	datatype => 'int',
    	base_name => 'item_type',
    	description => 'Only return articles with the respective type. Mapping for item_type is: 1 - Figure, 2 - Media, 3 - Dataset, 5 - Poster, 6 - Journal contribution, 7 - Presentation, 8 - Thesis, 9 - Software, 11 - Online resource, 12 - Preprint, 13 - Book, 14 - Conference contribution, 15 - Chapter, 16 - Peer review, 17 - Educational resource, 18 - Report, 19 - Standard, 20 - Composition, 21 - Funding, 22 - Physical object, 23 - Data management plan, 24 - Workflow, 25 - Monograph, 26 - Performance, 27 - Event, 28 - Service, 29 - Model',
    	format => '',
    	read_only => '',
    		},
    'doi' => {
    	datatype => 'string',
    	base_name => 'doi',
    	description => 'Only return articles with this doi',
    	format => '',
    	read_only => '',
    		},
    'handle' => {
    	datatype => 'string',
    	base_name => 'handle',
    	description => 'Only return articles with this handle',
    	format => '',
    	read_only => '',
    		},
    'project_id' => {
    	datatype => 'int',
    	base_name => 'project_id',
    	description => 'Only return articles in this project',
    	format => '',
    	read_only => '',
    		},
    'order' => {
    	datatype => 'string',
    	base_name => 'order',
    	description => 'The field by which to order',
    	format => '',
    	read_only => '',
    		},
    'search_for' => {
    	datatype => 'string',
    	base_name => 'search_for',
    	description => 'Search term',
    	format => '',
    	read_only => '',
    		},
    'page' => {
    	datatype => 'int',
    	base_name => 'page',
    	description => 'Page number. Used for pagination with page_size',
    	format => '',
    	read_only => '',
    		},
    'page_size' => {
    	datatype => 'int',
    	base_name => 'page_size',
    	description => 'The number of results included on a page. Used for pagination with page',
    	format => '',
    	read_only => '',
    		},
    'limit' => {
    	datatype => 'int',
    	base_name => 'limit',
    	description => 'Number of results included on a page. Used for pagination with query',
    	format => '',
    	read_only => '',
    		},
    'offset' => {
    	datatype => 'int',
    	base_name => 'offset',
    	description => 'Where to start the listing(the offset of the first result). Used for pagination with limit',
    	format => '',
    	read_only => '',
    		},
    'order_direction' => {
    	datatype => 'string',
    	base_name => 'order_direction',
    	description => 'Direction of ordering',
    	format => '',
    	read_only => '',
    		},
    'institution' => {
    	datatype => 'int',
    	base_name => 'institution',
    	description => 'only return collections from this institution',
    	format => '',
    	read_only => '',
    		},
    'published_since' => {
    	datatype => 'string',
    	base_name => 'published_since',
    	description => 'Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD',
    	format => '',
    	read_only => '',
    		},
    'modified_since' => {
    	datatype => 'string',
    	base_name => 'modified_since',
    	description => 'Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD',
    	format => '',
    	read_only => '',
    		},
    'group' => {
    	datatype => 'int',
    	base_name => 'group',
    	description => 'only return collections from this group',
    	format => '',
    	read_only => '',
    		},
    'resource_id' => {
    	datatype => 'string',
    	base_name => 'resource_id',
    	description => 'only return collections with this resource_id',
    	format => '',
    	read_only => '',
    		},
});

__PACKAGE__->swagger_types( {
    'resource_doi' => 'string',
    'item_type' => 'int',
    'doi' => 'string',
    'handle' => 'string',
    'project_id' => 'int',
    'order' => 'string',
    'search_for' => 'string',
    'page' => 'int',
    'page_size' => 'int',
    'limit' => 'int',
    'offset' => 'int',
    'order_direction' => 'string',
    'institution' => 'int',
    'published_since' => 'string',
    'modified_since' => 'string',
    'group' => 'int',
    'resource_id' => 'string'
} );

__PACKAGE__->attribute_map( {
    'resource_doi' => 'resource_doi',
    'item_type' => 'item_type',
    'doi' => 'doi',
    'handle' => 'handle',
    'project_id' => 'project_id',
    'order' => 'order',
    'search_for' => 'search_for',
    'page' => 'page',
    'page_size' => 'page_size',
    'limit' => 'limit',
    'offset' => 'offset',
    'order_direction' => 'order_direction',
    'institution' => 'institution',
    'published_since' => 'published_since',
    'modified_since' => 'modified_since',
    'group' => 'group',
    'resource_id' => 'resource_id'
} );

__PACKAGE__->mk_accessors(keys %{__PACKAGE__->attribute_map});


1;
