=begin comment

Figshare API

Figshare apiv2. Using Swagger 2.0

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git

=end comment

=cut

#
# NOTE: This class is auto generated by the swagger code generator program. 
# Do not edit the class manually.
# Ref: https://github.com/swagger-api/swagger-codegen
#
package WWW::SwaggerClient::OtherApi;

require 5.6.0;
use strict;
use warnings;
use utf8; 
use Exporter;
use Carp qw( croak );
use Log::Any qw($log);

use WWW::SwaggerClient::ApiClient;

use base "Class::Data::Inheritable";

__PACKAGE__->mk_classdata('method_documentation' => {});

sub new {
    my $class = shift;
    my $api_client;

    if ($_[0] && ref $_[0] && ref $_[0] eq 'WWW::SwaggerClient::ApiClient' ) {
        $api_client = $_[0];
    } else {
        $api_client = WWW::SwaggerClient::ApiClient->new(@_);
    }

    bless { api_client => $api_client }, $class;

}


#
# categories_list
#
# Public Categories
# 
{
    my $params = {
    };
    __PACKAGE__->method_documentation->{ 'categories_list' } = { 
    	summary => 'Public Categories',
        params => $params,
        returns => 'ARRAY[Category]',
        };
}
# @return ARRAY[Category]
#
sub categories_list {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/categories';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Category]', $response);
    return $_response_object;
}

#
# file_download
#
# Public File Download
# 
# @param int $file_id  (required)
{
    my $params = {
    'file_id' => {
        data_type => 'int',
        description => '',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'file_download' } = { 
    	summary => 'Public File Download',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub file_download {
    my ($self, %args) = @_;

    # verify the required parameter 'file_id' is set
    unless (exists $args{'file_id'}) {
      croak("Missing the required parameter 'file_id' when calling file_download");
    }

    # parse inputs
    my $_resource_path = '/file/download/{file_id}';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/force-download');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'file_id'}) {
        my $_base_variable = "{" . "file_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'file_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# item_types_list
#
# Item Types
# 
# @param int $group_id Identifier of the group for which the item types are requested (optional, default to 0)
{
    my $params = {
    'group_id' => {
        data_type => 'int',
        description => 'Identifier of the group for which the item types are requested',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'item_types_list' } = { 
    	summary => 'Item Types',
        params => $params,
        returns => 'ARRAY[ItemType]',
        };
}
# @return ARRAY[ItemType]
#
sub item_types_list {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/item_types';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # query params
    if ( exists $args{'group_id'}) {
        $query_params->{'group_id'} = $self->{api_client}->to_query_value($args{'group_id'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[ItemType]', $response);
    return $_response_object;
}

#
# licenses_list
#
# Public Licenses
# 
{
    my $params = {
    };
    __PACKAGE__->method_documentation->{ 'licenses_list' } = { 
    	summary => 'Public Licenses',
        params => $params,
        returns => 'ARRAY[License]',
        };
}
# @return ARRAY[License]
#
sub licenses_list {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/licenses';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[License]', $response);
    return $_response_object;
}

#
# private_account
#
# Private Account information
# 
{
    my $params = {
    };
    __PACKAGE__->method_documentation->{ 'private_account' } = { 
    	summary => 'Private Account information',
        params => $params,
        returns => 'Account',
        };
}
# @return Account
#
sub private_account {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/account';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('Account', $response);
    return $_response_object;
}

#
# private_funding_search
#
# Search Funding
# 
# @param FundingSearch $search Search Parameters (optional)
{
    my $params = {
    'search' => {
        data_type => 'FundingSearch',
        description => 'Search Parameters',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_funding_search' } = { 
    	summary => 'Search Funding',
        params => $params,
        returns => 'ARRAY[FundingInformation]',
        };
}
# @return ARRAY[FundingInformation]
#
sub private_funding_search {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/account/funding/search';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    my $_body_data;
    # body params
    if ( exists $args{'search'}) {
        $_body_data = $args{'search'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[FundingInformation]', $response);
    return $_response_object;
}

#
# private_licenses_list
#
# Private Account Licenses
# 
{
    my $params = {
    };
    __PACKAGE__->method_documentation->{ 'private_licenses_list' } = { 
    	summary => 'Private Account Licenses',
        params => $params,
        returns => 'ARRAY[License]',
        };
}
# @return ARRAY[License]
#
sub private_licenses_list {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/account/licenses';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[License]', $response);
    return $_response_object;
}

1;
