=begin comment

Figshare API

Figshare apiv2. Using Swagger 2.0

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git

=end comment

=cut

#
# NOTE: This class is auto generated by the swagger code generator program. 
# Do not edit the class manually.
# Ref: https://github.com/swagger-api/swagger-codegen
#
package WWW::SwaggerClient::ProjectsApi;

require 5.6.0;
use strict;
use warnings;
use utf8; 
use Exporter;
use Carp qw( croak );
use Log::Any qw($log);

use WWW::SwaggerClient::ApiClient;

use base "Class::Data::Inheritable";

__PACKAGE__->mk_classdata('method_documentation' => {});

sub new {
    my $class = shift;
    my $api_client;

    if ($_[0] && ref $_[0] && ref $_[0] eq 'WWW::SwaggerClient::ApiClient' ) {
        $api_client = $_[0];
    } else {
        $api_client = WWW::SwaggerClient::ApiClient->new(@_);
    }

    bless { api_client => $api_client }, $class;

}


#
# private_project_article_delete
#
# Delete project article
# 
# @param int $project_id Project unique identifier (required)
# @param int $article_id Project Article unique identifier (required)
{
    my $params = {
    'project_id' => {
        data_type => 'int',
        description => 'Project unique identifier',
        required => '1',
    },
    'article_id' => {
        data_type => 'int',
        description => 'Project Article unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_project_article_delete' } = { 
    	summary => 'Delete project article',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_project_article_delete {
    my ($self, %args) = @_;

    # verify the required parameter 'project_id' is set
    unless (exists $args{'project_id'}) {
      croak("Missing the required parameter 'project_id' when calling private_project_article_delete");
    }

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_project_article_delete");
    }

    # parse inputs
    my $_resource_path = '/account/projects/{project_id}/articles/{article_id}';

    my $_method = 'DELETE';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'project_id'}) {
        my $_base_variable = "{" . "project_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'project_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_project_article_details
#
# Project article details
# 
# @param int $project_id Project unique identifier (required)
# @param int $article_id Project Article unique identifier (required)
{
    my $params = {
    'project_id' => {
        data_type => 'int',
        description => 'Project unique identifier',
        required => '1',
    },
    'article_id' => {
        data_type => 'int',
        description => 'Project Article unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_project_article_details' } = { 
    	summary => 'Project article details',
        params => $params,
        returns => 'ProjectArticle',
        };
}
# @return ProjectArticle
#
sub private_project_article_details {
    my ($self, %args) = @_;

    # verify the required parameter 'project_id' is set
    unless (exists $args{'project_id'}) {
      croak("Missing the required parameter 'project_id' when calling private_project_article_details");
    }

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_project_article_details");
    }

    # parse inputs
    my $_resource_path = '/account/projects/{project_id}/articles/{article_id}';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'project_id'}) {
        my $_base_variable = "{" . "project_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'project_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ProjectArticle', $response);
    return $_response_object;
}

#
# private_project_article_file
#
# Project article file details
# 
# @param int $project_id Project unique identifier (required)
# @param int $article_id Project Article unique identifier (required)
# @param int $file_id File unique identifier (required)
{
    my $params = {
    'project_id' => {
        data_type => 'int',
        description => 'Project unique identifier',
        required => '1',
    },
    'article_id' => {
        data_type => 'int',
        description => 'Project Article unique identifier',
        required => '1',
    },
    'file_id' => {
        data_type => 'int',
        description => 'File unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_project_article_file' } = { 
    	summary => 'Project article file details',
        params => $params,
        returns => 'PrivateFile',
        };
}
# @return PrivateFile
#
sub private_project_article_file {
    my ($self, %args) = @_;

    # verify the required parameter 'project_id' is set
    unless (exists $args{'project_id'}) {
      croak("Missing the required parameter 'project_id' when calling private_project_article_file");
    }

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_project_article_file");
    }

    # verify the required parameter 'file_id' is set
    unless (exists $args{'file_id'}) {
      croak("Missing the required parameter 'file_id' when calling private_project_article_file");
    }

    # parse inputs
    my $_resource_path = '/account/projects/{project_id}/articles/{article_id}/files/{file_id}';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'project_id'}) {
        my $_base_variable = "{" . "project_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'project_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'file_id'}) {
        my $_base_variable = "{" . "file_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'file_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('PrivateFile', $response);
    return $_response_object;
}

#
# private_project_article_files
#
# Project article list files
# 
# @param int $project_id Project unique identifier (required)
# @param int $article_id Project Article unique identifier (required)
{
    my $params = {
    'project_id' => {
        data_type => 'int',
        description => 'Project unique identifier',
        required => '1',
    },
    'article_id' => {
        data_type => 'int',
        description => 'Project Article unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_project_article_files' } = { 
    	summary => 'Project article list files',
        params => $params,
        returns => 'ARRAY[PrivateFile]',
        };
}
# @return ARRAY[PrivateFile]
#
sub private_project_article_files {
    my ($self, %args) = @_;

    # verify the required parameter 'project_id' is set
    unless (exists $args{'project_id'}) {
      croak("Missing the required parameter 'project_id' when calling private_project_article_files");
    }

    # verify the required parameter 'article_id' is set
    unless (exists $args{'article_id'}) {
      croak("Missing the required parameter 'article_id' when calling private_project_article_files");
    }

    # parse inputs
    my $_resource_path = '/account/projects/{project_id}/articles/{article_id}/files';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'project_id'}) {
        my $_base_variable = "{" . "project_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'project_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'article_id'}) {
        my $_base_variable = "{" . "article_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'article_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[PrivateFile]', $response);
    return $_response_object;
}

#
# private_project_articles_create
#
# Create project article
# 
# @param int $project_id Project unique identifier (required)
# @param ArticleProjectCreate $article Article description (required)
# @param int $page Page number. Used for pagination with page_size (optional)
# @param int $page_size The number of results included on a page. Used for pagination with page (optional, default to 10)
# @param int $limit Number of results included on a page. Used for pagination with query (optional)
# @param int $offset Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
{
    my $params = {
    'project_id' => {
        data_type => 'int',
        description => 'Project unique identifier',
        required => '1',
    },
    'article' => {
        data_type => 'ArticleProjectCreate',
        description => 'Article description',
        required => '1',
    },
    'page' => {
        data_type => 'int',
        description => 'Page number. Used for pagination with page_size',
        required => '0',
    },
    'page_size' => {
        data_type => 'int',
        description => 'The number of results included on a page. Used for pagination with page',
        required => '0',
    },
    'limit' => {
        data_type => 'int',
        description => 'Number of results included on a page. Used for pagination with query',
        required => '0',
    },
    'offset' => {
        data_type => 'int',
        description => 'Where to start the listing(the offset of the first result). Used for pagination with limit',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_project_articles_create' } = { 
    	summary => 'Create project article',
        params => $params,
        returns => 'Location',
        };
}
# @return Location
#
sub private_project_articles_create {
    my ($self, %args) = @_;

    # verify the required parameter 'project_id' is set
    unless (exists $args{'project_id'}) {
      croak("Missing the required parameter 'project_id' when calling private_project_articles_create");
    }

    # verify the required parameter 'article' is set
    unless (exists $args{'article'}) {
      croak("Missing the required parameter 'article' when calling private_project_articles_create");
    }

    # parse inputs
    my $_resource_path = '/account/projects/{project_id}/articles';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # query params
    if ( exists $args{'page'}) {
        $query_params->{'page'} = $self->{api_client}->to_query_value($args{'page'});
    }

    # query params
    if ( exists $args{'page_size'}) {
        $query_params->{'page_size'} = $self->{api_client}->to_query_value($args{'page_size'});
    }

    # query params
    if ( exists $args{'limit'}) {
        $query_params->{'limit'} = $self->{api_client}->to_query_value($args{'limit'});
    }

    # query params
    if ( exists $args{'offset'}) {
        $query_params->{'offset'} = $self->{api_client}->to_query_value($args{'offset'});
    }

    # path params
    if ( exists $args{'project_id'}) {
        my $_base_variable = "{" . "project_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'project_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'article'}) {
        $_body_data = $args{'article'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('Location', $response);
    return $_response_object;
}

#
# private_project_articles_list
#
# List project articles
# 
# @param int $project_id Project unique identifier (required)
# @param int $page Page number. Used for pagination with page_size (optional)
# @param int $page_size The number of results included on a page. Used for pagination with page (optional, default to 10)
# @param int $limit Number of results included on a page. Used for pagination with query (optional)
# @param int $offset Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
{
    my $params = {
    'project_id' => {
        data_type => 'int',
        description => 'Project unique identifier',
        required => '1',
    },
    'page' => {
        data_type => 'int',
        description => 'Page number. Used for pagination with page_size',
        required => '0',
    },
    'page_size' => {
        data_type => 'int',
        description => 'The number of results included on a page. Used for pagination with page',
        required => '0',
    },
    'limit' => {
        data_type => 'int',
        description => 'Number of results included on a page. Used for pagination with query',
        required => '0',
    },
    'offset' => {
        data_type => 'int',
        description => 'Where to start the listing(the offset of the first result). Used for pagination with limit',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_project_articles_list' } = { 
    	summary => 'List project articles',
        params => $params,
        returns => 'ARRAY[Article]',
        };
}
# @return ARRAY[Article]
#
sub private_project_articles_list {
    my ($self, %args) = @_;

    # verify the required parameter 'project_id' is set
    unless (exists $args{'project_id'}) {
      croak("Missing the required parameter 'project_id' when calling private_project_articles_list");
    }

    # parse inputs
    my $_resource_path = '/account/projects/{project_id}/articles';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # query params
    if ( exists $args{'page'}) {
        $query_params->{'page'} = $self->{api_client}->to_query_value($args{'page'});
    }

    # query params
    if ( exists $args{'page_size'}) {
        $query_params->{'page_size'} = $self->{api_client}->to_query_value($args{'page_size'});
    }

    # query params
    if ( exists $args{'limit'}) {
        $query_params->{'limit'} = $self->{api_client}->to_query_value($args{'limit'});
    }

    # query params
    if ( exists $args{'offset'}) {
        $query_params->{'offset'} = $self->{api_client}->to_query_value($args{'offset'});
    }

    # path params
    if ( exists $args{'project_id'}) {
        my $_base_variable = "{" . "project_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'project_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Article]', $response);
    return $_response_object;
}

#
# private_project_collaborator_delete
#
# Remove project collaborator
# 
# @param int $project_id Project unique identifier (required)
# @param int $user_id User unique identifier (required)
{
    my $params = {
    'project_id' => {
        data_type => 'int',
        description => 'Project unique identifier',
        required => '1',
    },
    'user_id' => {
        data_type => 'int',
        description => 'User unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_project_collaborator_delete' } = { 
    	summary => 'Remove project collaborator',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_project_collaborator_delete {
    my ($self, %args) = @_;

    # verify the required parameter 'project_id' is set
    unless (exists $args{'project_id'}) {
      croak("Missing the required parameter 'project_id' when calling private_project_collaborator_delete");
    }

    # verify the required parameter 'user_id' is set
    unless (exists $args{'user_id'}) {
      croak("Missing the required parameter 'user_id' when calling private_project_collaborator_delete");
    }

    # parse inputs
    my $_resource_path = '/account/projects/{project_id}/collaborators/{user_id}';

    my $_method = 'DELETE';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'project_id'}) {
        my $_base_variable = "{" . "project_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'project_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'user_id'}) {
        my $_base_variable = "{" . "user_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'user_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_project_collaborators_invite
#
# Invite project collaborators
# 
# @param int $project_id Project unique identifier (required)
# @param ProjectCollaboratorInvite $collaborator viewer or collaborator role. User user_id or email of user (required)
{
    my $params = {
    'project_id' => {
        data_type => 'int',
        description => 'Project unique identifier',
        required => '1',
    },
    'collaborator' => {
        data_type => 'ProjectCollaboratorInvite',
        description => 'viewer or collaborator role. User user_id or email of user',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_project_collaborators_invite' } = { 
    	summary => 'Invite project collaborators',
        params => $params,
        returns => 'ResponseMessage',
        };
}
# @return ResponseMessage
#
sub private_project_collaborators_invite {
    my ($self, %args) = @_;

    # verify the required parameter 'project_id' is set
    unless (exists $args{'project_id'}) {
      croak("Missing the required parameter 'project_id' when calling private_project_collaborators_invite");
    }

    # verify the required parameter 'collaborator' is set
    unless (exists $args{'collaborator'}) {
      croak("Missing the required parameter 'collaborator' when calling private_project_collaborators_invite");
    }

    # parse inputs
    my $_resource_path = '/account/projects/{project_id}/collaborators';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'project_id'}) {
        my $_base_variable = "{" . "project_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'project_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'collaborator'}) {
        $_body_data = $args{'collaborator'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ResponseMessage', $response);
    return $_response_object;
}

#
# private_project_collaborators_list
#
# List project collaborators
# 
# @param int $project_id Project unique identifier (required)
{
    my $params = {
    'project_id' => {
        data_type => 'int',
        description => 'Project unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_project_collaborators_list' } = { 
    	summary => 'List project collaborators',
        params => $params,
        returns => 'ARRAY[ProjectCollaborator]',
        };
}
# @return ARRAY[ProjectCollaborator]
#
sub private_project_collaborators_list {
    my ($self, %args) = @_;

    # verify the required parameter 'project_id' is set
    unless (exists $args{'project_id'}) {
      croak("Missing the required parameter 'project_id' when calling private_project_collaborators_list");
    }

    # parse inputs
    my $_resource_path = '/account/projects/{project_id}/collaborators';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'project_id'}) {
        my $_base_variable = "{" . "project_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'project_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[ProjectCollaborator]', $response);
    return $_response_object;
}

#
# private_project_create
#
# Create project
# 
# @param ProjectCreate $project Project  description (required)
{
    my $params = {
    'project' => {
        data_type => 'ProjectCreate',
        description => 'Project  description',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_project_create' } = { 
    	summary => 'Create project',
        params => $params,
        returns => 'CreateProjectResponse',
        };
}
# @return CreateProjectResponse
#
sub private_project_create {
    my ($self, %args) = @_;

    # verify the required parameter 'project' is set
    unless (exists $args{'project'}) {
      croak("Missing the required parameter 'project' when calling private_project_create");
    }

    # parse inputs
    my $_resource_path = '/account/projects';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    my $_body_data;
    # body params
    if ( exists $args{'project'}) {
        $_body_data = $args{'project'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('CreateProjectResponse', $response);
    return $_response_object;
}

#
# private_project_delete
#
# Delete project
# 
# @param int $project_id Project unique identifier (required)
{
    my $params = {
    'project_id' => {
        data_type => 'int',
        description => 'Project unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_project_delete' } = { 
    	summary => 'Delete project',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_project_delete {
    my ($self, %args) = @_;

    # verify the required parameter 'project_id' is set
    unless (exists $args{'project_id'}) {
      croak("Missing the required parameter 'project_id' when calling private_project_delete");
    }

    # parse inputs
    my $_resource_path = '/account/projects/{project_id}';

    my $_method = 'DELETE';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'project_id'}) {
        my $_base_variable = "{" . "project_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'project_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_project_details
#
# View project details
# 
# @param int $project_id Project unique identifier (required)
{
    my $params = {
    'project_id' => {
        data_type => 'int',
        description => 'Project unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_project_details' } = { 
    	summary => 'View project details',
        params => $params,
        returns => 'ProjectCompletePrivate',
        };
}
# @return ProjectCompletePrivate
#
sub private_project_details {
    my ($self, %args) = @_;

    # verify the required parameter 'project_id' is set
    unless (exists $args{'project_id'}) {
      croak("Missing the required parameter 'project_id' when calling private_project_details");
    }

    # parse inputs
    my $_resource_path = '/account/projects/{project_id}';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'project_id'}) {
        my $_base_variable = "{" . "project_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'project_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ProjectCompletePrivate', $response);
    return $_response_object;
}

#
# private_project_leave
#
# Private Project Leave
# 
# @param int $project_id Project unique identifier (required)
{
    my $params = {
    'project_id' => {
        data_type => 'int',
        description => 'Project unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_project_leave' } = { 
    	summary => 'Private Project Leave',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_project_leave {
    my ($self, %args) = @_;

    # verify the required parameter 'project_id' is set
    unless (exists $args{'project_id'}) {
      croak("Missing the required parameter 'project_id' when calling private_project_leave");
    }

    # parse inputs
    my $_resource_path = '/account/projects/{project_id}/leave';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'project_id'}) {
        my $_base_variable = "{" . "project_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'project_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_project_note
#
# Project note details
# 
# @param int $project_id Project unique identifier (required)
# @param int $note_id Note unique identifier (required)
{
    my $params = {
    'project_id' => {
        data_type => 'int',
        description => 'Project unique identifier',
        required => '1',
    },
    'note_id' => {
        data_type => 'int',
        description => 'Note unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_project_note' } = { 
    	summary => 'Project note details',
        params => $params,
        returns => 'ProjectNotePrivate',
        };
}
# @return ProjectNotePrivate
#
sub private_project_note {
    my ($self, %args) = @_;

    # verify the required parameter 'project_id' is set
    unless (exists $args{'project_id'}) {
      croak("Missing the required parameter 'project_id' when calling private_project_note");
    }

    # verify the required parameter 'note_id' is set
    unless (exists $args{'note_id'}) {
      croak("Missing the required parameter 'note_id' when calling private_project_note");
    }

    # parse inputs
    my $_resource_path = '/account/projects/{project_id}/notes/{note_id}';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'project_id'}) {
        my $_base_variable = "{" . "project_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'project_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'note_id'}) {
        my $_base_variable = "{" . "note_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'note_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ProjectNotePrivate', $response);
    return $_response_object;
}

#
# private_project_note_delete
#
# Delete project note
# 
# @param int $project_id Project unique identifier (required)
# @param int $note_id Note unique identifier (required)
{
    my $params = {
    'project_id' => {
        data_type => 'int',
        description => 'Project unique identifier',
        required => '1',
    },
    'note_id' => {
        data_type => 'int',
        description => 'Note unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_project_note_delete' } = { 
    	summary => 'Delete project note',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_project_note_delete {
    my ($self, %args) = @_;

    # verify the required parameter 'project_id' is set
    unless (exists $args{'project_id'}) {
      croak("Missing the required parameter 'project_id' when calling private_project_note_delete");
    }

    # verify the required parameter 'note_id' is set
    unless (exists $args{'note_id'}) {
      croak("Missing the required parameter 'note_id' when calling private_project_note_delete");
    }

    # parse inputs
    my $_resource_path = '/account/projects/{project_id}/notes/{note_id}';

    my $_method = 'DELETE';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'project_id'}) {
        my $_base_variable = "{" . "project_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'project_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'note_id'}) {
        my $_base_variable = "{" . "note_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'note_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_project_note_update
#
# Update project note
# 
# @param int $project_id Project unique identifier (required)
# @param int $note_id Note unique identifier (required)
# @param ProjectNoteCreate $note Note message (required)
{
    my $params = {
    'project_id' => {
        data_type => 'int',
        description => 'Project unique identifier',
        required => '1',
    },
    'note_id' => {
        data_type => 'int',
        description => 'Note unique identifier',
        required => '1',
    },
    'note' => {
        data_type => 'ProjectNoteCreate',
        description => 'Note message',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_project_note_update' } = { 
    	summary => 'Update project note',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_project_note_update {
    my ($self, %args) = @_;

    # verify the required parameter 'project_id' is set
    unless (exists $args{'project_id'}) {
      croak("Missing the required parameter 'project_id' when calling private_project_note_update");
    }

    # verify the required parameter 'note_id' is set
    unless (exists $args{'note_id'}) {
      croak("Missing the required parameter 'note_id' when calling private_project_note_update");
    }

    # verify the required parameter 'note' is set
    unless (exists $args{'note'}) {
      croak("Missing the required parameter 'note' when calling private_project_note_update");
    }

    # parse inputs
    my $_resource_path = '/account/projects/{project_id}/notes/{note_id}';

    my $_method = 'PUT';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'project_id'}) {
        my $_base_variable = "{" . "project_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'project_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    # path params
    if ( exists $args{'note_id'}) {
        my $_base_variable = "{" . "note_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'note_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'note'}) {
        $_body_data = $args{'note'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_project_notes_create
#
# Create project note
# 
# @param int $project_id Project unique identifier (required)
# @param ProjectNoteCreate $note Note message (required)
{
    my $params = {
    'project_id' => {
        data_type => 'int',
        description => 'Project unique identifier',
        required => '1',
    },
    'note' => {
        data_type => 'ProjectNoteCreate',
        description => 'Note message',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_project_notes_create' } = { 
    	summary => 'Create project note',
        params => $params,
        returns => 'Location',
        };
}
# @return Location
#
sub private_project_notes_create {
    my ($self, %args) = @_;

    # verify the required parameter 'project_id' is set
    unless (exists $args{'project_id'}) {
      croak("Missing the required parameter 'project_id' when calling private_project_notes_create");
    }

    # verify the required parameter 'note' is set
    unless (exists $args{'note'}) {
      croak("Missing the required parameter 'note' when calling private_project_notes_create");
    }

    # parse inputs
    my $_resource_path = '/account/projects/{project_id}/notes';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'project_id'}) {
        my $_base_variable = "{" . "project_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'project_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'note'}) {
        $_body_data = $args{'note'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('Location', $response);
    return $_response_object;
}

#
# private_project_notes_list
#
# List project notes
# 
# @param int $project_id Project unique identifier (required)
# @param int $page Page number. Used for pagination with page_size (optional)
# @param int $page_size The number of results included on a page. Used for pagination with page (optional, default to 10)
# @param int $limit Number of results included on a page. Used for pagination with query (optional)
# @param int $offset Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
{
    my $params = {
    'project_id' => {
        data_type => 'int',
        description => 'Project unique identifier',
        required => '1',
    },
    'page' => {
        data_type => 'int',
        description => 'Page number. Used for pagination with page_size',
        required => '0',
    },
    'page_size' => {
        data_type => 'int',
        description => 'The number of results included on a page. Used for pagination with page',
        required => '0',
    },
    'limit' => {
        data_type => 'int',
        description => 'Number of results included on a page. Used for pagination with query',
        required => '0',
    },
    'offset' => {
        data_type => 'int',
        description => 'Where to start the listing(the offset of the first result). Used for pagination with limit',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_project_notes_list' } = { 
    	summary => 'List project notes',
        params => $params,
        returns => 'ARRAY[ProjectNote]',
        };
}
# @return ARRAY[ProjectNote]
#
sub private_project_notes_list {
    my ($self, %args) = @_;

    # verify the required parameter 'project_id' is set
    unless (exists $args{'project_id'}) {
      croak("Missing the required parameter 'project_id' when calling private_project_notes_list");
    }

    # parse inputs
    my $_resource_path = '/account/projects/{project_id}/notes';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # query params
    if ( exists $args{'page'}) {
        $query_params->{'page'} = $self->{api_client}->to_query_value($args{'page'});
    }

    # query params
    if ( exists $args{'page_size'}) {
        $query_params->{'page_size'} = $self->{api_client}->to_query_value($args{'page_size'});
    }

    # query params
    if ( exists $args{'limit'}) {
        $query_params->{'limit'} = $self->{api_client}->to_query_value($args{'limit'});
    }

    # query params
    if ( exists $args{'offset'}) {
        $query_params->{'offset'} = $self->{api_client}->to_query_value($args{'offset'});
    }

    # path params
    if ( exists $args{'project_id'}) {
        my $_base_variable = "{" . "project_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'project_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[ProjectNote]', $response);
    return $_response_object;
}

#
# private_project_publish
#
# Private Project Publish
# 
# @param int $project_id Project unique identifier (required)
{
    my $params = {
    'project_id' => {
        data_type => 'int',
        description => 'Project unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_project_publish' } = { 
    	summary => 'Private Project Publish',
        params => $params,
        returns => 'ResponseMessage',
        };
}
# @return ResponseMessage
#
sub private_project_publish {
    my ($self, %args) = @_;

    # verify the required parameter 'project_id' is set
    unless (exists $args{'project_id'}) {
      croak("Missing the required parameter 'project_id' when calling private_project_publish");
    }

    # parse inputs
    my $_resource_path = '/account/projects/{project_id}/publish';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'project_id'}) {
        my $_base_variable = "{" . "project_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'project_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ResponseMessage', $response);
    return $_response_object;
}

#
# private_project_update
#
# Update project
# 
# @param int $project_id Project unique identifier (required)
# @param ProjectUpdate $project Project description (required)
{
    my $params = {
    'project_id' => {
        data_type => 'int',
        description => 'Project unique identifier',
        required => '1',
    },
    'project' => {
        data_type => 'ProjectUpdate',
        description => 'Project description',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_project_update' } = { 
    	summary => 'Update project',
        params => $params,
        returns => undef,
        };
}
# @return void
#
sub private_project_update {
    my ($self, %args) = @_;

    # verify the required parameter 'project_id' is set
    unless (exists $args{'project_id'}) {
      croak("Missing the required parameter 'project_id' when calling private_project_update");
    }

    # verify the required parameter 'project' is set
    unless (exists $args{'project'}) {
      croak("Missing the required parameter 'project' when calling private_project_update");
    }

    # parse inputs
    my $_resource_path = '/account/projects/{project_id}';

    my $_method = 'PUT';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'project_id'}) {
        my $_base_variable = "{" . "project_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'project_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # body params
    if ( exists $args{'project'}) {
        $_body_data = $args{'project'};
    }

    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    return;
}

#
# private_projects_list
#
# Private Projects
# 
# @param int $page Page number. Used for pagination with page_size (optional)
# @param int $page_size The number of results included on a page. Used for pagination with page (optional, default to 10)
# @param int $limit Number of results included on a page. Used for pagination with query (optional)
# @param int $offset Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
# @param string $order The field by which to order. (optional, default to published_date)
# @param string $order_direction  (optional, default to desc)
# @param string $storage only return collections from this institution (optional)
# @param string $roles Any combination of owner, collaborator, viewer separated by comma. Examples: \&quot;owner\&quot; or \&quot;owner,collaborator\&quot;. (optional)
{
    my $params = {
    'page' => {
        data_type => 'int',
        description => 'Page number. Used for pagination with page_size',
        required => '0',
    },
    'page_size' => {
        data_type => 'int',
        description => 'The number of results included on a page. Used for pagination with page',
        required => '0',
    },
    'limit' => {
        data_type => 'int',
        description => 'Number of results included on a page. Used for pagination with query',
        required => '0',
    },
    'offset' => {
        data_type => 'int',
        description => 'Where to start the listing(the offset of the first result). Used for pagination with limit',
        required => '0',
    },
    'order' => {
        data_type => 'string',
        description => 'The field by which to order.',
        required => '0',
    },
    'order_direction' => {
        data_type => 'string',
        description => '',
        required => '0',
    },
    'storage' => {
        data_type => 'string',
        description => 'only return collections from this institution',
        required => '0',
    },
    'roles' => {
        data_type => 'string',
        description => 'Any combination of owner, collaborator, viewer separated by comma. Examples: \&quot;owner\&quot; or \&quot;owner,collaborator\&quot;.',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_projects_list' } = { 
    	summary => 'Private Projects',
        params => $params,
        returns => 'ARRAY[ProjectPrivate]',
        };
}
# @return ARRAY[ProjectPrivate]
#
sub private_projects_list {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/account/projects';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # query params
    if ( exists $args{'page'}) {
        $query_params->{'page'} = $self->{api_client}->to_query_value($args{'page'});
    }

    # query params
    if ( exists $args{'page_size'}) {
        $query_params->{'page_size'} = $self->{api_client}->to_query_value($args{'page_size'});
    }

    # query params
    if ( exists $args{'limit'}) {
        $query_params->{'limit'} = $self->{api_client}->to_query_value($args{'limit'});
    }

    # query params
    if ( exists $args{'offset'}) {
        $query_params->{'offset'} = $self->{api_client}->to_query_value($args{'offset'});
    }

    # query params
    if ( exists $args{'order'}) {
        $query_params->{'order'} = $self->{api_client}->to_query_value($args{'order'});
    }

    # query params
    if ( exists $args{'order_direction'}) {
        $query_params->{'order_direction'} = $self->{api_client}->to_query_value($args{'order_direction'});
    }

    # query params
    if ( exists $args{'storage'}) {
        $query_params->{'storage'} = $self->{api_client}->to_query_value($args{'storage'});
    }

    # query params
    if ( exists $args{'roles'}) {
        $query_params->{'roles'} = $self->{api_client}->to_query_value($args{'roles'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw(OAuth2 )];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[ProjectPrivate]', $response);
    return $_response_object;
}

#
# private_projects_search
#
# Private Projects search
# 
# @param ProjectsSearch $search Search Parameters (optional)
{
    my $params = {
    'search' => {
        data_type => 'ProjectsSearch',
        description => 'Search Parameters',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'private_projects_search' } = { 
    	summary => 'Private Projects search',
        params => $params,
        returns => 'ARRAY[ProjectPrivate]',
        };
}
# @return ARRAY[ProjectPrivate]
#
sub private_projects_search {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/account/projects/search';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    my $_body_data;
    # body params
    if ( exists $args{'search'}) {
        $_body_data = $args{'search'};
    }

    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[ProjectPrivate]', $response);
    return $_response_object;
}

#
# project_articles
#
# Public Project Articles
# 
# @param int $project_id Project Unique identifier (required)
{
    my $params = {
    'project_id' => {
        data_type => 'int',
        description => 'Project Unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'project_articles' } = { 
    	summary => 'Public Project Articles',
        params => $params,
        returns => 'ARRAY[Article]',
        };
}
# @return ARRAY[Article]
#
sub project_articles {
    my ($self, %args) = @_;

    # verify the required parameter 'project_id' is set
    unless (exists $args{'project_id'}) {
      croak("Missing the required parameter 'project_id' when calling project_articles");
    }

    # parse inputs
    my $_resource_path = '/projects/{project_id}/articles';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'project_id'}) {
        my $_base_variable = "{" . "project_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'project_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Article]', $response);
    return $_response_object;
}

#
# project_details
#
# Public Project
# 
# @param int $project_id Project Unique identifier (required)
{
    my $params = {
    'project_id' => {
        data_type => 'int',
        description => 'Project Unique identifier',
        required => '1',
    },
    };
    __PACKAGE__->method_documentation->{ 'project_details' } = { 
    	summary => 'Public Project',
        params => $params,
        returns => 'ProjectComplete',
        };
}
# @return ProjectComplete
#
sub project_details {
    my ($self, %args) = @_;

    # verify the required parameter 'project_id' is set
    unless (exists $args{'project_id'}) {
      croak("Missing the required parameter 'project_id' when calling project_details");
    }

    # parse inputs
    my $_resource_path = '/projects/{project_id}';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # path params
    if ( exists $args{'project_id'}) {
        my $_base_variable = "{" . "project_id" . "}";
        my $_base_value = $self->{api_client}->to_path_value($args{'project_id'});
        $_resource_path =~ s/$_base_variable/$_base_value/g;
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ProjectComplete', $response);
    return $_response_object;
}

#
# projects_list
#
# Public Projects
# 
# @param UUID $x_cursor Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)
# @param int $page Page number. Used for pagination with page_size (optional)
# @param int $page_size The number of results included on a page. Used for pagination with page (optional, default to 10)
# @param int $limit Number of results included on a page. Used for pagination with query (optional)
# @param int $offset Where to start the listing(the offset of the first result). Used for pagination with limit (optional)
# @param string $order The field by which to order. Default varies by endpoint/resource. (optional, default to published_date)
# @param string $order_direction  (optional, default to desc)
# @param int $institution only return collections from this institution (optional)
# @param string $published_since Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD (optional)
# @param int $group only return collections from this group (optional)
{
    my $params = {
    'x_cursor' => {
        data_type => 'UUID',
        description => 'Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected.',
        required => '0',
    },
    'page' => {
        data_type => 'int',
        description => 'Page number. Used for pagination with page_size',
        required => '0',
    },
    'page_size' => {
        data_type => 'int',
        description => 'The number of results included on a page. Used for pagination with page',
        required => '0',
    },
    'limit' => {
        data_type => 'int',
        description => 'Number of results included on a page. Used for pagination with query',
        required => '0',
    },
    'offset' => {
        data_type => 'int',
        description => 'Where to start the listing(the offset of the first result). Used for pagination with limit',
        required => '0',
    },
    'order' => {
        data_type => 'string',
        description => 'The field by which to order. Default varies by endpoint/resource.',
        required => '0',
    },
    'order_direction' => {
        data_type => 'string',
        description => '',
        required => '0',
    },
    'institution' => {
        data_type => 'int',
        description => 'only return collections from this institution',
        required => '0',
    },
    'published_since' => {
        data_type => 'string',
        description => 'Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD',
        required => '0',
    },
    'group' => {
        data_type => 'int',
        description => 'only return collections from this group',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'projects_list' } = { 
    	summary => 'Public Projects',
        params => $params,
        returns => 'ARRAY[Project]',
        };
}
# @return ARRAY[Project]
#
sub projects_list {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/projects';

    my $_method = 'GET';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # query params
    if ( exists $args{'page'}) {
        $query_params->{'page'} = $self->{api_client}->to_query_value($args{'page'});
    }

    # query params
    if ( exists $args{'page_size'}) {
        $query_params->{'page_size'} = $self->{api_client}->to_query_value($args{'page_size'});
    }

    # query params
    if ( exists $args{'limit'}) {
        $query_params->{'limit'} = $self->{api_client}->to_query_value($args{'limit'});
    }

    # query params
    if ( exists $args{'offset'}) {
        $query_params->{'offset'} = $self->{api_client}->to_query_value($args{'offset'});
    }

    # query params
    if ( exists $args{'order'}) {
        $query_params->{'order'} = $self->{api_client}->to_query_value($args{'order'});
    }

    # query params
    if ( exists $args{'order_direction'}) {
        $query_params->{'order_direction'} = $self->{api_client}->to_query_value($args{'order_direction'});
    }

    # query params
    if ( exists $args{'institution'}) {
        $query_params->{'institution'} = $self->{api_client}->to_query_value($args{'institution'});
    }

    # query params
    if ( exists $args{'published_since'}) {
        $query_params->{'published_since'} = $self->{api_client}->to_query_value($args{'published_since'});
    }

    # query params
    if ( exists $args{'group'}) {
        $query_params->{'group'} = $self->{api_client}->to_query_value($args{'group'});
    }

    # header params
    if ( exists $args{'x_cursor'}) {
        $header_params->{'X-Cursor'} = $self->{api_client}->to_header_value($args{'x_cursor'});
    }

    my $_body_data;
    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Project]', $response);
    return $_response_object;
}

#
# projects_search
#
# Public Projects Search
# 
# @param UUID $x_cursor Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected. (optional)
# @param ProjectsSearch $search Search Parameters (optional)
{
    my $params = {
    'x_cursor' => {
        data_type => 'UUID',
        description => 'Unique hash used for bypassing the item retrieval limit of 9,000 entities. When using this parameter, please note that the offset parameter will not be available, but the limit parameter will still work as expected.',
        required => '0',
    },
    'search' => {
        data_type => 'ProjectsSearch',
        description => 'Search Parameters',
        required => '0',
    },
    };
    __PACKAGE__->method_documentation->{ 'projects_search' } = { 
    	summary => 'Public Projects Search',
        params => $params,
        returns => 'ARRAY[Project]',
        };
}
# @return ARRAY[Project]
#
sub projects_search {
    my ($self, %args) = @_;

    # parse inputs
    my $_resource_path = '/projects/search';

    my $_method = 'POST';
    my $query_params = {};
    my $header_params = {};
    my $form_params = {};

    # 'Accept' and 'Content-Type' header
    my $_header_accept = $self->{api_client}->select_header_accept('application/json');
    if ($_header_accept) {
        $header_params->{'Accept'} = $_header_accept;
    }
    $header_params->{'Content-Type'} = $self->{api_client}->select_header_content_type();

    # header params
    if ( exists $args{'x_cursor'}) {
        $header_params->{'X-Cursor'} = $self->{api_client}->to_header_value($args{'x_cursor'});
    }

    my $_body_data;
    # body params
    if ( exists $args{'search'}) {
        $_body_data = $args{'search'};
    }

    # authentication setting, if any
    my $auth_settings = [qw()];

    # make the API Call
    my $response = $self->{api_client}->call_api($_resource_path, $_method,
                                           $query_params, $form_params,
                                           $header_params, $_body_data, $auth_settings);
    if (!$response) {
        return;
    }
    my $_response_object = $self->{api_client}->deserialize('ARRAY[Project]', $response);
    return $_response_object;
}

1;
